	page 132,60
;		       Bootloader to replace bootloader ;-)
;		    Copyright 1989, Digital-Signal Systems, Inc.
;				2/19/89 BM
;
;
;*****************************************************************************
;
;
;
;			Do equates to all on board peripherals
;

	include 'ioequ'

;****************************************************************************
;
;			Do equates for all interrupt vectors
;
;****************************************************************************

	include 'intequ'

;****************************************************************************
;									    *
;			Main Program to boot from host			    *
;									    *
;****************************************************************************

start	equ	$0
	org	p:start
;
;	It is necessary to comment-out the following two instructions
;	in order to make the source code from Bob McGwier match the
;	code given us in the DSP ROM.  Andy Madsen 12-Nov-93.
;
;GO	movec	#6,OMR		; set operating mode to 2 and enable on
				; on board data ROM (sinusoids)
;	andi	#$0,CCR		; clear SR as if reset
	andi	#$F3,MR		; clear scaling bits
	nop
	movep	#>$0002,x:M_BCR	; just make sure that external memory is
				; set to 0 wait states (we paid for so lets
				; use it!)
				; 3 wait states for external peripherals
				; because of the GD 8254 and the 85C30.
	movep	y0,y:$FFF4	; let go initialization latch
	movep	#1,x:M_PBC	; enable host port
	nop
	bset	#M_HF2,x:<<M_HCR	; set HF2 and wait until HF0 is cleared
;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;IDLE	jset	#M_HF0,x:<<M_HSR,IDLE	; If HF0 is a one, wait until it isn't
	jset	#M_HF0,x:<<M_HSR,IDLE	; If HF0 is a one, wait until it isn't
;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;	bclr	#M_HF2,x:<<M_HCR	; clear HF2 as the final handshake
IDLE	bclr	#M_HF2,x:<<M_HCR	; clear HF2 as the final handshake
;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;CLOOP	jset	#M_HF0,x:<<M_HSR,$1F00	; after load, HF0 is set, jump to
	jset	#M_HF0,x:<<M_HSR,$1F00	; after load, HF0 is set, jump to
					; second loader
;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;	jclr	#M_HRDF,x:<<M_HSR,CLOOP ; While we are waiting for the first
CLOOP	jclr	#M_HRDF,x:<<M_HSR,CLOOP ; While we are waiting for the first
					; memory record, check HF0
	clr	b			; clear the junk out of B
	movep	x:M_HRX,b1	; move the data receive into b1

	move	#$FF,y1		; Get mask for memory character
	move	#'P',y0		; Is this a P memory record?
	tfr	b,a		; Save B
	and	y1,a		; Mask off memory space control word
	cmp	y0,a		; compare against a 'P'
	jeq	<MEMLDP		; Yes

	move	#'X',y0		; Is this an X memory record?
	cmp	y0,a		; compare against a 'X'
	jeq	<MEMLDX		; Yes

	move	#'Y',y0		; Is this a Y memory record?
	cmp	y0,a		; compare against a 'Y'
	jeq	<MEMLDY		; Yes

	jmp	<CLOOP		; Somebody screwed the pooch or it's the
				; dummy record at the beginning
;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;MEMLDP	move	#>$FFFF,y0	; It was a P memory load, get address
	move	#>$FFFF,y0	; It was a P memory load, get address
;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;	tfr	b,a		; get the original command
MEMLDP	tfr	b,a		; get the original command
	and	y0,a		; mask off the address
	move	a1,r0		; load the address into the r0 register
	jsr	<RCVWD		; get it
	tfr	b,a		; This is the word count
;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;DOLPM	move	#>1,y0		; load 1 into Y0
	move	#>1,y0		; load 1 into Y0
;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;	sub	y0,a		; decrement a (we cannot use data memory)
DOLPM	sub	y0,a		; decrement a (we cannot use data memory)
	jlt	<CLOOP		; Reached the end of the memory data record?
	jsr	<RCVWD		; No, go get the next word
	movem	b1,P:(r0)+	; Store it into p:(R0) and then increment R0
	jmp	<DOLPM		; go back to top of load loop

;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;MEMLDX	move	#>$FFFF,y0	; identical to above, except X memory
	move	#>$FFFF,y0	; identical to above, except X memory
;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;	tfr	b,a
MEMLDX	tfr	b,a
	and	y0,a
	move	a1,r0
	jsr	<RCVWD
	tfr	b,a
;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;DOLXM	move	#>1,y0
	move	#>1,y0
;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;	sub	y0,a
DOLXM	sub	y0,a
	jlt	<CLOOP
	jsr	<RCVWD
	move	b1,X:(r0)+
	jmp	<DOLXM

;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;MEMLDY	move	#>$FFFF,y0	; identical to P, except we have Y memory
	move	#>$FFFF,y0	; identical to P, except we have Y memory
;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;	tfr	b,a
MEMLDY	tfr	b,a
	and	y0,a
	move	a1,r0
	jsr	<RCVWD
	tfr	b,a
;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;DOLYM	move	#>1,y0
	move	#>1,y0
;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;	sub	y0,a
DOLYM	sub	y0,a
	jlt	<CLOOP
	jsr	<RCVWD
	move	b1,Y:(r0)+
	jmp	<DOLYM

;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;RCVWD	jclr	#M_HRDF,x:<<M_HSR,RCVWD	; If there's no data, try again
	jclr	#M_HRDF,x:<<M_HSR,RCVWD	; If there's no data, try again
;	The following instruction had to be replaced wit the instruction below
;	to get the code to assemble as per the loader received from Bob McGwier.
;	clr	b			; Get rid of any crap
RCVWD	clr	b			; Get rid of any crap
	movep	x:M_HRX,b1		; move the data receive into b1
	rts
	end
