	page 132,60
;		       Bootloader to replace bootloader ;-)
;		    Copyright 1989, Digital-Signal Systems, Inc.
;				2/19/89 BM N4HY
;
;
;*****************************************************************************
;
;
;
;			Do equates to all on board peripherals
;

	include 'ioequ'

;****************************************************************************
;
;			Do equates for all interrupt vectors
;
;****************************************************************************

	include 'intequ'

;****************************************************************************
;									    *
;			Main Program to boot from host			    *
;									    *
;****************************************************************************

start	equ	$1F00
	org	p:start

GO	bset	#M_HF2,x:<<M_HCR	; set HF2 and wait until HF0 is cleared
IDLE	jset	#M_HF0,x:<<M_HSR,IDLE	; If HF0 is a one, wait until it isn't
	bclr	#M_HF2,x:<<M_HCR	; clear HF2 as the final handshake

	movep	#>$36,y:$FFEB		;  Set Timer 0 on Chip A for FILTER
;The next instruction was commented out and replaced with the following 
;instruction to fit differences observed in the load file we received. A.M.
;	movep	#>$10,y:$FFE8
	movep	#>$0F,y:$FFE8
	movep	#>0,y:$FFE8

	movep	#>$76,y:$FFEB		; 
	movep	#>$10,y:$FFE9
	movep	#>0,y:$FFE9

	movep	#>$B4,y:$FFEB
	movep	#>$80,y:$FFEA
	movep	#>$2,y:$FFEA

	movep	#>$36,y:$FFEF
	movep	#>$10,y:$FFEC
	movep	#>0,y:$FFEC

	movep	#>$76,y:$FFEF
	movep	#>$10,y:$FFED
	movep	#>0,y:$FFED

	movep	#>$B6,y:$FFEF
	movep	#>$80,y:$FFEE
	movep	#>$2,y:$FFEE

	movep	#>$0,y:$FFC8
	movep	y0,y:$FFCC

	movep	#>$451451,y:$FFC8
	movep	y0,y:$FFCC

	movep	#>$492492,y:$FFC8
	movep	y0,y:$FFCC

	movep	#>$C30C3,y:$FFC8
	movep	y0,y:$FFCC

	movep	#>$D34D34,y:$FFC8
	movep	y0,y:$FFCC

	movep	#>$D75D75,y:$FFC8
	movep	y0,y:$FFCC

	movep	#>$186186,y:$FFC8
	movep	y0,y:$FFCC

	movep	#>$5D75D7,y:$FFC8
	movep	y0,y:$FFCC

	movep	#>$208208,y:$FFC8
	movep	y0,y:$FFCC

	movep	#>$659659,y:$FFC8
	movep	y0,y:$FFCC

	movep	#>$69A69A,y:$FFC8
	movep	y0,y:$FFCC

	movep	#>$2CB2CB,y:$FFC8
	movep	y0,y:$FFCC

	movep	#>$30C30C,y:$FFC8
	movep	y0,y:$FFCC

	movep	#>$F7DF7D,y:$FFC8
	movep	y0,y:$FFCC

	movep	#>$38E38E,y:$FFC8
	movep	y0,y:$FFCC

	movep	#>$3CF3CF,y:$FFC8
	movep	y0,y:$FFCC



CLOOP	jset	#M_HF0,x:<<M_HSR,$0	; after load, HF0 is set, jump to
					; program
	jclr	#M_HRDF,x:<<M_HSR,CLOOP ; While we are waiting for 
					; memory record, check HF0
	clr	b			; clear the shit out of B
	movep	x:M_HRX,b1	; move the data receive into b1

	move	#$FF,y1		; Get mask for memory character
	move	#'P',y0		; Is this a P memory record?
	tfr	b,a		; Save B
	and	y1,a		; Mask off memory space control word
	cmp	y0,a		; compare against a 'P'
	jeq	MEMLDP		; Yes

	move	#'X',y0		; Is this an X memory record?
	cmp	y0,a		; compare against a 'X'
	jeq	MEMLDX		; Yes

	move	#'Y',y0		; Is this a Y memory record?
	cmp	y0,a		; compare against a 'Y'
	jeq	MEMLDY		; Yes

	jmp	CLOOP		; Somebody screwed the pooch or it's the
				; dummy record at the beginning

MEMLDP	move	#>$FFFF,y0	; It was a P memory load, get address
	tfr	b,a		; get the original command
	and	y0,a		; mask off the address
	move	a1,r0		; load the address into the r0 register
	jsr	RCVWD		; get it
	tfr	b,a		; This is the word count
DOLPM	move	#>1,y0		; load 1 into Y0
	sub	y0,a		; decrement a (we cannot use data memory)
	jlt	CLOOP		; Reached the end of the memory data record?
	jsr	RCVWD		; No, go get the next word
	movem	b1,P:(r0)+	; Store it into p:(R0) and then increment R0
	jmp	DOLPM		; go back to top of load loop

MEMLDX	move	#>$FFFF,y0	; identical to above, except X memory
	tfr	b,a
	and	y0,a
	move	a1,r0
	jsr	RCVWD
	tfr	b,a
DOLXM	move	#>1,y0
	sub	y0,a
	jlt	CLOOP
	jsr	RCVWD
	move	b1,X:(r0)+
	jmp	DOLXM

MEMLDY	move	#>$FFFF,y0	; identical to P, except we have Y memory
	tfr	b,a
	and	y0,a
	move	a1,r0
	jsr	RCVWD
	tfr	b,a
DOLYM	move	#>1,y0
	sub	y0,a
	jlt	CLOOP
	jsr	RCVWD
	move	b1,Y:(r0)+
	jmp	DOLYM

RCVWD	jclr	#M_HRDF,x:<<M_HSR,RCVWD	; If there's no data, try again
	clr	b			; Get rid of any junk
	movep	x:M_HRX,b1		; move the data receive into b1
	rts
	end
