	page	132,60
;	V26B Port-1 2400 bps PACKET modem.  1800 Hz carrier freq.
;	Modified 15-Nov-93 for new bar graph communications protocol.
;	by Andy Madsen KB7B.
;	standard I/O 
	include 'ioequ'

;	interrupt equates
	include 'intequ'

;	bit shift macros
	include 'shifty'

;	DSP232 IO Equates
	include	'dsp232'

BLANKBG2	equ	$800800		;constnt blanks unused port-2 bar graph

	org	x:$30
RXB	ds	1
TXB	dc	$800000
INTREQ	dc	0
rphase	dc	0			; receive phase
freq	dc	1800*524288/9600	; receiver freq
tfreq	dc	1800*524288/9600	; transmit carrier freq.
ophase	dc	0			; transmit phase
xn5	dc	0
txclk	dc	0
tphase	dc	524288
clkcr	dc	16384
clksm   dc      0.98
clkgn	dc	0.04
clkdcd	dc	0

	org	y:$0
bp	dc      -27977
	dc      125838
	dc     -179254
	dc     -190650
	dc       16074
	dc     -379908
	dc     -351078
	dc      -10753
	dc     -725625
	dc     -542267
	dc      160201
	dc    -1401470
	dc     -666527
	dc     4075381
	dc     4075381
	dc     -666527
	dc    -1401470
	dc      160201
	dc     -542267
	dc     -725625
	dc      -10753
	dc     -351078
	dc     -379908
	dc       16074
	dc     -190650
	dc     -179254
	dc      125838
	dc      -27977

	org	y:$30
RXA	dc	0
TXA	dc	0
HDIM	dc	$FC
clkph	dc	0
clkfq	dc	524288*1200/9600
pi	dc	$40000
pio4	dc	65536
thpio4	dc	65536*3
fpio4	dc	65536*5
spio4	dc	65536*7
dcdoff	dc	0.005
;	Hilbert transform filter

	org	y:$40
hilby
	dc      -60284
	dc     -135229
	dc     -283344
	dc       55746
	dc     -166647
	dc     -273431
	dc      205651
	dc     -101189
	dc     -172401
	dc      792729
	dc      197100
	dc      264742
	dc     3410894
	dc     2707068
	dc    -2707068
	dc    -3410894
	dc     -264742
	dc     -197100
	dc     -792729
	dc      172401
	dc      101189
	dc     -205651
	dc      273431
	dc      166647
	dc      -55746
	dc      283344
	dc      135229
	dc       60284

maskph	dc	$7FFFF			;  maskph = 524287
bpr	dc	0
bpx	dc	0
prtph	dc	0
iptr	dc	0
qptr	dc	0
biptr	dc	0
bqptr	dc	0

	org	x:$600
bpxmt	ds	30

	org	x:$640
dati	ds	15

	org	x:$650
datq	ds	15

minb	dc	0

	 org	y:$80
lpbb	dc       4593
	dc      77561
	dc      80973
	dc      86000
	dc      52363
	dc     -21924
	dc    -122901
	dc    -217779
	dc    -261234
	dc    -208863
	dc     -33147
	dc     263115
	dc     641276
	dc    1033136
	dc    1356970
	dc    1540224
	dc    1540224
	dc    1356970
	dc    1033136
	dc     641276
	dc     263115
	dc     -33147
	dc    -208863
	dc    -261234
	dc    -217779
	dc    -122901
	dc     -21924
	dc      52363
	dc      86000
	dc      80973
	dc      77561
	dc       4593


;	Lowpass filter for baseband


	org	x:$A0
deli	ds	15

	org	y:$A0
delq	ds	15

	org	x:$440
biti	ds	32

	org	x:$480
bitq	ds	32


	org	p:0
	jmp	start

	org 	p:I_IRQA
	jsr	<CH_A

	org 	p:I_IRQB
	jsr	<CH_B

	org	p:$40

loopt	bclr	#0,x:INTREQ
	movep	y0,y:INITL
	jcc	<loopt

	move	x:txclk,a	; get txclk counter
	move	#1,x0		; add one to it
 	add	x0,a
	move	a1,x:txclk	; save it
	move	#4,x0		; is it 8?
	cmp	x0,a	#2,x1	; compare and get halfbittime ready to compare
	jeq	<stlow		; was it fullbittime?
	cmp	x1,a		; no, check if its halfbittime
	jne	<dodat		; none of the above, move on
	bset	#2,y:HDIM	; set clock bit high
	movep	y:HDIM,y:HSTW	; get it and send it to the 85C30
	bclr	#2,x:INTREQ
	jcs	<sndb
	bset	#2,x:INTREQ
	jclr	#3,y:<<HSTR,lob1
	bset	#3,x:INTREQ
	jmp	<dodat	
lob1	bclr	#3,x:INTREQ
	jmp	<dodat		; move on
sndb	move	x:ophase,x0
	btst	#3,x:INTREQ
	jcc	<fb0
	jclr	#3,y:<<HSTR,lob2
tmpj	move	y:fpio4,a
	jmp	<addph
lob2	move	y:spio4,a
	jmp	<addph
fb0	jclr	#3,y:<<HSTR,lob3
	move	y:thpio4,a
	jmp	<addph
lob3	move	y:pio4,a
addph	add	x0,a	y:maskph,x0
	and	x0,a
	move	a,x:ophase
	jmp	<dodat

stlow	move	#0,x0
	move	x0,x:txclk	; the clock time was fullbittime

	bclr	#2,y:HDIM	; clear the clock bit
	movep	y:HDIM,y:HSTW	; get it and send it to the 85C30

dodat	move	x:xn5,n5
	move	#27,m1
	move	#bp,r4
	move	n5,b			; Read phase into b1
	move	#>$40,x1		; Get ninety degrees
	move	#>$FF,y1		; Get 2pi mask
	add	x1,b	y:(r5+n5),y0	; add 90 degrees to get cos(phase)
					; whilst reading in sin(phase)
	and	y1,b	y:bpr,r1	; mask to make between 0 and 2pi
					; whilst reading in the signal from
					; center of the delay line
	move	b1,n5			; move this into offset register

	move	y:RXA,x1
	move	y:(r5+n5),x0		; Get cos(phase)=sin(phase+90)


	clr	a	x1,x:(r1)+	y:(r4)+,y1	; set up acc & ptr's
	rep	#27					; for bandpass filt
	mac	x1,y1,a	x:(r1)+,x1	y:(r4)+,y1	; do convolution
	move	#hilby,r4				; move the Hilbert table ptrs in
	macr	x1,y1,a					; last term and DO NOT reset ptr

	clr	b	x:(r1)+,x1	y:(r4)+,y1	; Set up Hilby
	rep	#27					; do convolution
	mac	-x1,y1,b	x:(r1)+,x1	y:(r4)+,y1
	macr	-x1,y1,b	(r1)-	; Do last multiply and reset data ptr

	move	b,y1
	move	a,x1

 	mpy	x0,x1,a	r1,y:bpr			; compute deli[0]
	macr	y0,y1,a					; basebanded real part



	move	#31,m1
	mpy	-y0,x1,b				; compute delq[0]
	macr	x0,y1,b	y:biptr,r1			; baseband imag. part

	move	#lpbb,r4
	move	a,x0

	clr	a	x0,x:(r1)+	y:(r4)+,y0
	rep	#31
	mac	x0,y0,a	x:(r1)+,x0	y:(r4)+,y0
	macr	x0,y0,a	(r1)-
	move	r1,y:biptr

	move	y:bqptr,r1
	move	#lpbb,r4
	move	b,x0
	clr	b	x0,x:(r1)+	y:(r4)+,y0
	rep	#31
	mac	x0,y0,b	x:(r1)+,x0	y:(r4)+,y0
	macr	x0,y0,b	(r1)-
	move	r1,y:bqptr

	move	a,y:(r2)				; store i channel
	move	b,x:(r6)				; store q channel
	move	y:(r2+n2),y1	b,x0
	move	x:(r6+n6),x1	a,y0	; Do differential detection


	mpy	y0,y1,a
	macr	x0,x1,a	(r6)-

	mpy	x0,y1,b
	macr	-y0,x1,b (r2)-


	move	#8,m1
	move	#1,n1
	move	#lpbb,r4
	move	y:iptr,r1
	move	a,x0
	clr	a	x0,x:(r0)+	y:(r4)+,y0
	rep	#31
	mac	x0,y0,a	x:(r0)+,x0	y:(r4)+,y0
	macr	x0,y0,a	(r0)-
	move	a,x:(r1)
	move	#lpbb,r4


	move	b,x0
	clr	b	x0,x:(r3)+	y:(r4)+,y0
	rep	#31
	mac	x0,y0,b	x:(r3)+,x0	y:(r4)+,y0
	move	#8,m4
	move	#1,n4
	macr	x0,y0,b	(r3)-
	move	y:qptr,r4

;	Do clock recovery and integrate and dump on clock

	move	x:(r1+n1),y0
	move	b,x:(r4)	
	move	x:(r1),x0
	move	y:clkph,a
	mpy	x0,y0,b	x:(r4+n4),x1
	jlt	<adjc
	move	x:(r4),x0
	mpy	x0,x1,b	
	jgt	<nocrct
adjc	move	y:pi,x1
	cmp	x1,a	x:clkcr,x0
	jlt	<addit
	sub	x0,a
	jmp	<stacph
addit	add	x0,a
stacph	move	a,y:clkph

nocrct	bclr	#8,x:INTREQ
	jcc	<ckafq		; If bit time was not set, jmp past decision
	move	#4,n4		; get pointers ready to compare bit center
	move	#4,n1		; with bit edge to determine DCD
	move	x:(r4),b	; get the bit from the Q channel
	tst	b
	jgt	<negb		; If the Q channel is < 0, then bit 1 was 1


	bset	#3,y:HDIM		; send the bit to the host
	jmp	<send1
negb	bclr	#3,y:HDIM
send1

	movep	y:HDIM,y:<<HSTW		;send data before clock to stabelize

	bset	#1,y:HDIM
	movep	y:HDIM,y:<<HSTW		; playing cautious, I set the bit

	bclr	#1,y:HDIM		; then I bang it high.  With 3 wait
	movep	y:HDIM,y:<<HSTW		; states, this should easily exceed
					; the required delay

;	DCD determination
	move	x:(r1+n1),a		; Get last bit edge from I channel
	abs	a	x:(r4+n4),b	; Get last bit edge from Q channel
	abs	b			; take abs value of both
	add	a,b			; add and store in the 
	asr	b
	move	b,x:minb		; minimum value slot
	move	x:(r4),b		; Get the current bit estimate from Q
	abs	b	x:(r1),a	; and the one from the I channel
	abs	a	x:minb,x0	; take abs of both & retrieve the bit
	add	a,b	x:clkdcd,x1	; edge value. Get the old DCD value
	asr	b			
	sub	x0,b	x:clkgn,y0	; subtract edge value from center val.
	move	b,x0			; and get ready to smooth the result
	mpy	x0,y0,b	x:clksm,y1	; multiply the current difference by
	macr	x1,y1,b	y:dcdoff,y0	; the gain and the old DCD value by
	sub	y0,b	b,x:clkdcd	; the exponential filter value
					; and subtract the threshold
	jgt	<dcdon			; Is the dcd positive?
	bset	#0,y:HDIM		; NO so set /DCD to one
	jmp	<goon			; go on to next step
dcdon	bclr	#0,y:HDIM		; YES, set /DCD to zero
goon	move	x:(r1),b
	tst	b
	jgt	<nega
	bset	#3,y:HDIM		; send the bit to the host
	jmp	<send2
nega	bclr	#3,y:HDIM
send2 	bset	#1,y:HDIM
	movep	y:HDIM,y:<<HSTW		; playing cautious, I set the bit

	bclr	#1,y:HDIM		; then I bang it high.  With 3 wait
	movep	y:HDIM,y:<<HSTW		; states, this should easily exceed

dspclc	jclr	#M_HTDE,x:<<M_HSR,ckafq
doled	move	#>0.00000175,y0
	move	b,x0
mul	mpy	x0,y0,a	#>$F00,x0	;changed move here to $F00 from $800.
	move	a1,x1
	MSHL	x1,y0,8,a		;changed from shift left 16 to 8
	move	a0,a1
	and	x0,a			;changed from or to and
	movep	a1,x:M_HTX

ckafq	move	y:clkph,a
	move	y:clkfq,x0
	add	x0,a	x:tphase,x0
	cmp	x0,a	y:maskph,x1
	jlt	<stph
	and	x1,a
	bset	#8,x:INTREQ
stph	move	a,y:clkph
	move	x:(r4)-,x0
	move	x:(r1)-,x0
	move	r4,y:qptr
	move	r1,y:iptr

;	Carrier tone generation follows

cargen	move 	x:freq,x0	; multiply times gain*pherr for update
	move	x:rphase,b	; to freq. and get old freq
	move	#$FFFF,m4

					; lower fq rail for compare
	add	x0,b	y:maskph,x0	; add freq correction to fq
	and	x0,b
 	move	b1,x:rphase		; store updated phase
	move	b1,x1
	MSHR	x1,y1,11,a
	move	a1,x:xn5		; store offset into sine table


;	Transmitter code follows

xmtr	jset	#1,y:<<HSTR,xmtmk
	move	#$80,x0
	move	x0,y:TXA
	jmp	<loopt
xmtmk	move	x:tfreq,y0		; No so load up hi tone freq
comph	move	x:ophase,a		; Get the output phase
	add	y0,a	y:maskph,y1	; add the current freq and get the
					; Mod 2PI mask
	and	y1,a			; mask off for the next phase
	move	a1,x0			; Get phase read to pick off table
	move	#@pow(2,-11),y0		; offset to value by shifting right
	mpy	x0,y0,a	x0,x:ophase	; eleven bits and leaving top eight
					; and store the new output phase
	move	a1,n5			; store this in the offset pointer
	move	a0,y:prtph
;	We do a linear interpolation to clean up the crud

	move	#>1,x0
	move	y:(r5+n5),y0	;  Get the value of sine before phase
	add	x0,a	y0,b	;  add one to the pointer to get the next
				;  value in the table and store the first
				; value in y0
	neg	b	#>$FF,y1 ; take the negative and get mask for pointer
	and	y1,a		; mask off to make sure it is in the table
	move	a1,n5		; store the pointer in the offset register
	nop			; wait for hardware to catch up
	move	y:(r5+n5),x0	; store the next value in x0
	add	x0,b		; add it to the last value to get the amount
	clr	a		; of change in the sinusoid for one sample
	move	y:prtph,a1	; time.  retrieve the partial phase
	lsr	a	b1,x0	; lsr since it is inherently positive &
				; retrieve the change in sine to x0
	move	a1,x1		; store the partial phase in x1
	move	y0,b		; put the first sinusoid value in b
	macr	x1,x0,b	#bp,r4	; after this b will contain sin(st)
				; prtph*(sin(st+1)-sin(st) & get bandpass
				; filter pointer for transmit shaping
	move	#27,m1
	move	b,x1		; move sinusoid into place for filtering
	move	y:bpx,r1	; get the transmit filter data pointer
	nop
	clr	b	x1,x:(r1)+	y:(r4)+,y1
	rep	#27
	mac	x1,y1,b	x:(r1)+,x1	y:(r4)+,y1
	macr	x1,y1,b	(r1)-
	asr	b		; scale b so that we don't overhit the mike
txfix	move	#$80,x0			; Move the non 2's binary offset for
					; D/A into position
	add	x0,b			; add D/A fixup and retrieve PLL phase

	move	b1,y:TXA		; move output value into holding place
	move	r1,y:bpx		; store the transmit data pointer
	jmp	<loopt			

;	INTERRUPT SERVICE ROUTINES

CH_A	movep	y:ADA,y:RXA		; receive sample
	movep	y:TXA,y:DAA
	bset	#0,x:INTREQ
CH_B	rti


	org	p:$1000

start	bset	#M_HF2,x:<<M_HCR
IDLE	jset	#M_HF0,x:<<M_HSR,IDLE
	bclr	#M_HF2,x:<<M_HCR

	movep	#>BLANKBG2,x:M_HTX	;send BG 2 blanking to 64180 Host

	move	#hilby,r0
	move	#lpbb,r3

	move	#31,m3
	move	#31,m0

	move	#biti,y0
	move	y0,y:biptr

	move	#bitq,y0
	move	y0,y:bqptr

	move	#dati,y0
	move	y0,y:iptr

	move	#datq,y0
	move	y0,y:qptr

	move	#bp,y0
	move	y0,y:bpr

	move	#bpxmt,y0
	move	y0,y:bpx


	move	#deli,r2
	move	#8,m2
	move	#8,n2
	move	#delq,r6
	move	#8,m6
	move	#8,n6	
;

	move	#$100,r5		; Set up sinetable pointer


	move	#$300,SR
	movep	#$3F,x:$FFFF		; Set up interrupts
	move	#0,SR
	jmp	<loopt

	end

