	page	132,60
;	standard I/O 
	include 'ioequ'

; PSK 4800 bps modem radio port 1
;	Modified 15-Nov-93 for new bar graph communications protocol.
;	by Andy Madsen KB7B.

;	interrupt equates
	include 'intequ'

;	bit shift macros
	include 'shifty'

;	DSP232 IO Equates
	include	'dsp232'

ONE	equ	0.3
MONE	equ	-0.3
BLANKBG2	equ	$800800		;constnt blanks unused port-2 bar graph

	org	x:$60
datint	ds	8
bit	ds	1
txclk	dc	0
xn0	ds	1
	org	y:0
RXA	dc	0
TXA	dc	0
maskph	dc	$7FFFF			;  maskph = 524287
clkph	dc	0
clkfql	dc	65436
clkfq	dc	65536
clkfqh	dc	65736
dcdgo	dc	8288608
dcdgn	dc	100000
dcd	dc	0
dcdoff	dc	225000
pi	dc	$40000
pie	dc	$40000-16384
pil	dc	$40000+16384

	org	x:$300
INTREQ	dc	0
phase	dc	0			; initial phase
freq	dc	87381			; freq  1600 Hz
freql	dc	43691			; freql 1000 Hz
freqh	dc	131072			; freqh 2200 Hz
tfreq	dc	(1600*524288/9600)
fgain	dc	0.00015			; freq  gain
pgain	dc	0.006 			; phase gain
tphase	dc	524288			; 2^19 top of the phase chart!
ophase	dc	0			; transmit phase
pherr	dc	0
bitval	dc	0
tmp	dc	0
clkcr	dc	10000

	org	y:$80

bp	dc	  94550
	dc	-160455
	dc	-116695
	dc	  -5992
	dc	-343712
	dc	-328939
	dc	    786
	dc	-565587
	dc	-717522
	dc	 133762
	dc	-738199
	dc	-1577523
	dc	1820792
	dc	4781206
	dc	1820792
	dc	-1577523
	dc	-738199
	dc	 133762
	dc	-717522
	dc	-565587
	dc	    786
	dc	-328939
	dc	-343712
	dc	  -5992
	dc	-116695
	dc	-160455
	dc	  94550

	 org	y:$20

;	Lowpass filter for baseband

lpbb	dc	    1111
	dc	   89824
	dc	   79969
	dc	   72521
	dc	   24087
	dc	  -62528
	dc	 -164899
	dc	 -242921
	dc	 -248542
	dc	 -141500
	dc	   93937
	dc	  438301
	dc	  836562
	dc	 1209541
	dc	 1474929
	dc	 1571009
	dc	 1474929
	dc	 1209541
	dc	  836562
	dc	  438301
	dc	   93937
	dc	 -141500
	dc	 -248542
	dc	 -242921
	dc	 -164899
	dc	  -62528
	dc	   24087
	dc	   72521
	dc	   79969
	dc	   89824
	dc	    1111

	org	y:$40

hilby	dc	-245382
	dc	-123920
	dc	 -23674
	dc	-184504
	dc	-244108
	dc	 139348
	dc	 -73976
	dc	-273716
	dc	 584296
	dc	 438661
	dc	-180416
	dc	2042633
	dc	3670128
	dc	0
	dc	-3670128
	dc	-2042633
	dc	180416
	dc	-438661
	dc	-584296
	dc	273716
	dc	 73976
	dc	 -139348
	dc	244108
	dc	184504
	dc	 23674
	dc	123920
	dc	245382

	org	y:$60
hdim	dc	$FC
txsig	dc	MONE


	org	p:0
	jmp	<start

	org	p:I_IRQA
	jsr	<CH_A

	org	p:I_IRQB
	jsr	<CH_B


	org	p:$40

start	bset	#M_HF2,x:<<M_HCR
IDLE	jset	#M_HF0,x:<<M_HSR,IDLE
	bclr	#M_HF2,x:<<M_HCR

	movep	#>$36,y:$FFEB
	movep	#>$03,y:$FFE8
	movep	#>0,y:$FFE8

	movep	#>$76,y:$FFEB
	movep	#>$3,y:$FFE9
	movep	#>0,y:$FFE9

	movep	#>$B4,y:$FFEB
	movep	#>$A0,y:$FFEA
	movep	#>$0,y:$FFEA

	movep	#>$36,y:$FFEF
	movep	#>$3,y:$FFEC
	movep	#>0,y:$FFEC

	movep	#>$76,y:$FFEF
	movep	#>$3,y:$FFED
	movep	#>0,y:$FFED

	movep	#>$B4,y:$FFEF
	movep	#>$A0,y:$FFEE
	movep	#>$0,y:$FFEE

	movep	#>BLANKBG2,x:M_HTX	;send BG 2 blanking to 64180 Host


	move	#$300,SR
	movep	#$7,x:$FFFF		; Set up interrupts
	move	#0,SR


	move	#$100,r0		; Set up sinetable pointer

	move	#lpbb,r2		; Set up data filter (lowpass)
	move	#30,m2			; r6 is data and r2 is coeff
	move	#lpbb,r6		; filter is fifteen taps
	move	#30,m6			; 

	move	#datint,r3
	move	#7,m3
	move	#1,n3

	move	#hilby,r1		; get data for both BP and Hilby
	move	#26,m1			; delay line pointer
	move	#bp,r5			; move the BP table ptrs
	move	#26,m5


loopt	bclr	#0,x:INTREQ
	jcc	<loopt
	move	x:txclk,a	; get txclk counter
	move	#1,x0		; add one to it
	add	x0,a	#8,y0   ; and 1 to txclk and get 8 ready for compare
	move	a1,x:txclk	; save it
	cmp	y0,a	#4,x1	; compare for 8 and get 4 ready to compare
	jeq	<stlow		; was it eight?
	cmp	x1,a		; no, check if its four
	jne	<dodat		; none of the above, move on
	bset	#2,y:hdim	; set clock bit high
	movep	y:hdim,y:HSTW	; get it and send it to the 85C30
	jmp	<dodat		; go get transmit sample ready

stlow	move	#0,x0		; get a for the counter (immediate to mem would
				; help immensely!)
	move	x0,x:txclk	; the clock time was 8 (i.e. 0), store it.
	bclr	#2,y:hdim	; clear the clock bit
	movep	y:hdim,y:HSTW	; get it and  send it to the 85C30
	move	#>MONE,a	; get -1 and assume bit is zero
	jclr	#3,y:<<HSTR,txstr  ; test it
				; if it is, we are happy
	move	#>ONE,a		; if not, negate it.
txstr	move	a,y:txsig

dodat	move	#hilby,r4
	move	y:RXA,x0

	clr	a	x0,x:(r1)+	y:(r4)+,y0	; Set up Hilby
	rep	#26					; do convolution
	mac	-x0,y0,a	x:(r1)+,x0	y:(r4)+,y0
	macr	-x0,y0,a			; Do last multiply and 
						; get r4 ready for bandpass

	clr	b	x:(r1)+,x0	y:(r5)+,y0	; Set up bandpass
	rep	#26					; do convolution
	mac	x0,y0,b	x:(r1)+,x0	y:(r5)+,y0
	macr	x0,y0,b	(r1)-		; Do last multiply and reset data ptr
	move	b,x0



	clr	b	#>$40,x1	; Get ninety degrees
	move	n0,b1			; Read phase into b1
	move	#>$FF,y1		; Get 2pi mask
	add	x1,b	y:(r0+n0),y0	; add 90 degrees to get cos(phase)
					; whilst reading in sin(phase)
	and	y1,b			; mask to make between 0 and 2pi

	move	b1,n0			; move this into offset register


	move	a,x1

	move	y:(r0+n0),y1		; Get cos(phase)=sin(phase+90)

;	Get error estimate

	mpy	x1,y1,a 		; multiply signal*cos(phase)
	macr	-x0,y0,a		; and hilbert Xform(sig) * sin(phase)
					; and subtract
					; This gives data*SIN(It's - Mine)

;	Get data estimate,assuming error is `small enough'


	mpy	x0,y1,b			; Form hilb(sig)*cos(phase)
	macr	x1,y0,b			; +sig*sin(phase) to give data*
					; cos(It's - mine)

	jge	posb			; assuming small enough (It's - mine)
	neg	a			; negate the pherr if the bit < 0
posb	move	a1,x:pherr		; store it for future use
	move	a1,x0
	move	b1,x:bitval		; store noisy bit estimate
	mpy	-x0,x0,a	b1,x0	; compute Q^2 - I^2 for lock signal
	macr	x0,x0,a	y:dcdgn,y0	; 
	move	a1,x0
	mpy	x0,y0,a	y:dcd,x1
	move	y:dcdgo,y1
	macr	x1,y1,a	y:dcdoff,x0
	sub	x0,a	a1,y:dcd
	jlt	<dcdno			; Is the dcd positive?
	bclr	#0,y:hdim		; Yes so set /DCD to zero
	jmp	<goon			; go on to next step
dcdno	bset	#0,y:hdim		; DCD off, set /DCD to one
goon	move	x:pherr,y0		; move ph. err. est. in for fq gain
	move	x:fgain,x0		; Get freq. update gain
	mpy	x0,y0,a	x:freq,x0	; multiply times gain*pherr for update
					; to freq. and get old freq

	;  fq update and get lower fq rail for compare
	add	x0,a	x:freql,x1		; add freq correction to fq
	cmp	x1,a	x:freqh,x0	; Is the freq to low? Get freqh in case
	jgt	<chkhi			; phase is ok?
	move	x1,a			; No fq too low change to low
	jmp	<doph			; go update the phase
chkhi	cmp	x0,a			; is the freq too high?
	jlt	<doph			; No go to phase update
	move	x0,a			; Yes store high frequency
doph	move	x:pherr,x0		; Get the phase error estimate
	move	x:pgain,y0		; and the phase error gain
	mpy	x0,y0,b	x:phase,x1	; mpy to get phase update
	add	x1,b			; and add old phase to pherr update
	add	a,b	y:maskph,y0	; add new fq to phase, get phase mask
	tst	a
	jge	<phok			; if phase not < 0 go jump ahead
	move	x:tphase,x0		; if so, get 2*PI
	add	x0,b			; add 2*PI to make positive

phok	and	y0,b	a1,x:freq	; store new freq
	move	b1,x1			; mask off by 0x7FFFF
 	move	b1,x:phase		; store updated phase
	MSHR	x1,y1,11,a
	move	a1,x:xn0		; store offset into sine table

;	FILTER THE DATA	

	move	x:bitval,x1

bitflt	clr	b	x1,x:(r2)+	y:(r6)+,y1
	rep	#30
	mac	x1,y1,b	x:(r2)+,x1	y:(r6)+,y1
	macr	x1,y1,b	(r2)-	


;	FILTER DONE


;	Do clock recovery and integrate and dump on clock
;
	move	b,x:(r3)
	move	b,y0	x:(r3+n3),x0
	move	y:clkph,a		; comparison to adjust clkph
	mpy	x0,y0,b	y:pie,x1		; multiply them and get pi for phase
	jgt	<chkclk			
	cmp	x1,a	x:clkcr,x0	; compare pi with clock phase and
					; DPLL with phase change 1/2 reported
					; error.
					; Assumes 2 flags are sent before
					; straddles true bit edge worst case
					; with no noise induced crossings
	jlt	<addit			; if pi if less than a, move 2 degrees
					; to zero
	move	y:pil,x1
	cmp	x1,a
	jlt	<nocrct
	sub	x0,a
	jmp	<nocrct
addit	add	x0,a
nocrct	move	a,y:clkph

chkclk	bclr	#8,x:INTREQ
	jcc	<ckafq

	move	x:bit,b
	tst	b
	jlt	<negb
	bset	#3,y:hdim		; send the bit to the host
	jmp	<sendit
negb	bclr	#3,y:hdim
sendit

	movep	y:hdim,y:<<HSTW		;send data before clock to stabelize

	bset	#1,y:hdim
	movep	y:hdim,y:HSTW		; playing cautious, I set the bit

	bclr	#1,y:hdim		; then I bang it high.  With 3 wait
	movep	y:hdim,y:HSTW		; states, this should easily exceed

	jclr	#1,x:<<M_HSR,ckafq	; If it is no okay to Xmit, don't.
	
doled	move	x:freq,a
	move	#>87381,x0
	sub	x0,a
	move	a1,x0
	move	#>0.0001,y0
	mpy	x0,y0,a	#>$F00,x0	;changed move here to $F00 from $800.
	move	a1,x1
	MSHL	x1,y0,8,a		;changed from shift left 16 to 8
	move	a0,a1
	and	x0,a			;changed from or to and
	movep	a1,x:M_HTX

ckafq	move	y:clkph,a
	move	y:clkfq,x0
	add	x0,a	x:tphase,x0
	cmp	x0,a	y:maskph,x0
	jlt	<stph
	and	x0,a
	bset	#8,x:INTREQ
	move	x:(r3),x0
	move	x0,x:bit
stph	move	a,y:clkph
	move	x:(r3)-,x0

xmtr	jset	#1,y:<<HSTR,xmtmk
	move	#$80,x0
	move	x0,y:TXA
	move	x:xn0,n0
	jmp	<loopt
xmtmk	move	x:tfreq,y0
comph	move	x:ophase,a		; Get the output phase
	add	y0,a	y:maskph,y1	; add the current freq and get the
					; Mod 2PI mask
	and	y1,a			; mask off for the next phase
	move	a1,x0			; Get phase read to pick off table
	move	#@pow(2,-11),y0		; offset to value by shifting right
	mpy	x0,y0,a	x0,x:ophase	; eleven bits and leaving top eight
					; and store the new output phase
	move	a1,n0			; store this in the offset pointer

;	We do a linear interpolation to clean up the crud
	move	#>1,x0
	move	y:(r0+n0),y0
	add	x0,a	y0,b
	neg	b	#>$FF,y1
	and	y1,a
	move	a1,n0
	nop
	move	y:(r0+n0),x0
	add	x0,b
	clr	a
	move	a0,a1
	lsr	a	b1,x0
	move	a1,x1
	move	y0,b
	macr	x1,x0,b	y:txsig,y0
	move	b,x0
	mpyr	x0,y0,b
	move	#$80,x0			; Move the non 2's binary offset for
					; D/A into position
	add	x0,b	x:xn0,n0	; add D/A fixup and retrieve PLL phase

	move	b1,y:TXA		; move output value into holding place
	jmp	<loopt			; the minimum requirements

;	INTERRUPT SERVICE ROUTINES

CH_A	movep	y:ADA,y:RXA		; receive sample
	movep	y:TXA,y:DAA
	bset	#0,x:INTREQ
CH_B	rti

	end
