	page	132,60
;	9600 baud direct FSK modem for the DSP-2232 Port-2
;	Modified 15-Nov-93 for new bar graph communications protocol.
;	by Andy Madsen KB7B.
;	standard I/O 
	include 'ioequ'

;	interrupt equates
	include 'intequ'

;	bit shift macros
	include 'shifty'

;	DSP232 IO Equates
	include	'dsp232'

;	Numeric Macro's
;	include 'numerics'

ONE	equ	0.8
MONE	equ	-0.8
BLANKBG1	equ	$000800		;constnt blanks unused port-1 bar graph

	org	y:0
RXA	dc	0
TXA	dc	0
maskph	dc	$7FFFF			;  maskph = 524287
clkph	dc	0
clkfq	dc	65536
pi	dc	$40000
pie	dc	$40000-16384
pil	dc	$40000+16384
hdim	dc	$FC
dcdoff	dc	0.09
eqerr	dc	0
	org	x:0
INTREQ	dc	0
RXB	dc	0
TXB	dc	$800000
phase	dc	0			; initial phase 	0
tphase	dc	524288			; 2^19 top of the phase chart!
clkcr	dc	16371
clksm   dc      0.99
clkgn	dc	0.01
clkdcd	dc	0
shfregr	dc	0
shfregt	dc	0
txclk	dc	0
bit	dc	0

	org	x:$40
datint	ds	16

	org	x:$60
eqdly	ds	16
	org	y:$60
eqcoef	dc	0
	dc	0
	dc	0
	dc	0
	dc	0
	dc	0.5
	dc	0
	dc	0
	dc	0
	dc	0
	dc	0
	dc	0
	dc	0
	dc	0
	dc	0
	dc	0


	org	p:0
	jmp	<start

	org	p:I_IRQA
	jsr	<CH_A

	org	p:I_IRQB
	jsr	<CH_B

	org	p:$40

start	bset	#M_HF2,x:<<M_HCR	; Tell HOST processor we are here
IDLE	jset	#M_HF0,x:<<M_HSR,IDLE	; wait for Host processor to say hello
	bclr	#M_HF2,x:<<M_HCR	; Tell host processor we heard

	movep	#>$36,y:$FFEF		;  Set Timer 0 on Chip A for FILTER
	movep	#>$6,y:$FFEC
	movep	#>0,y:$FFEC

	movep	#>$76,y:$FFEF		; 
	movep	#>$6,y:$FFED
	movep	#>0,y:$FFED

	movep	#>$B4,y:$FFEF
	movep	#>$50,y:$FFEE
	movep	#>$0,y:$FFEE


	movep	#>BLANKBG1,x:M_HTX	;send BG 1 blanking to 64180 Host


	move	#$300,SR
	movep	#$38,x:$FFFF		; Set up interrupts
	move	#0,SR

	move	#datint+4,r7
	move	#15,m7
	move	#datint,r3
	move	#15,m3
	move	#1,n3

	move	#eqdly,r2
	move	#15,m2
	move	#5,n2

	move	#eqcoef,r6
	move	#15,m6
	move	#5,n6

;	ABOVE LINE TEMPORARY	REMOVE

loopt	bclr	#0,x:INTREQ
	jcc	<loopt
	move	x:txclk,a	; get txclk counter
	move	#1,x0		; add one to it
	add	x0,a
	move	a1,x:txclk	; save it
	move	#8,x0		; is it 8?
	cmp	x0,a	#4,x1	; compare and get 4 ready to compare
	jeq	<stlow		; was it eight?
	cmp	x1,a		; no, check if its four
	jne	<gtop		; none of the above, move on
	bset	#6,y:hdim	; set clock bit high
	movep	y:hdim,y:HSTW	; get it and send it to the 85C30
	jmp	<gtop		; move on

stlow	move	#0,x0
	move	x0,x:txclk	; the clock time was 8 (i.e. 0)
	bclr	#6,y:hdim	; clear the clock bit
	movep	y:hdim,y:HSTW	; get it and  send it to the 85C30


	jset	#5,y:<<HSTR,xmtmk
	move	#$80,x0
	move	x0,y:TXA
	jmp	<gtop
xmtmk	jclr	#7,y:<<HSTR,zerb
	move	#>1,b
	jmp	<scrmb
zerb	clr	b	
scrmb	move	x:shfregt,a
 	lsl	a	b1,x1
	eor	x1,a	#>1,x0
	jclr	#11,x:shfregt,tck17
	eor	x0,a
tck17	jclr	#16,x:shfregt,tbito
	eor	x0,a
tbito	move	a1,x:shfregt
	and	x0,a
	jeq	<nbit
	move	#>ONE,a
	jmp	<bfu
nbit	move	#>MONE,a	
bfu	move	#$80,x0			; Move the non 2's binary offset for
					; D/A into position
	add	x0,a			; add D/A fixup and retrieve PLL phase

	move	a1,y:TXA		; send it


gtop	move	y:RXA,b


goarnd	move	b,x:(r3)
	move	b,y0	x:(r3+n3),x0
	move	y:clkph,a		; comparison to adjust clkph
	mpy	x0,y0,b	y:pie,x1		; multiply them and get pi for phase
	jgt	<nocrct			
	cmp	x1,a	x:clkcr,x0	; compare pi with clock phase and
					; DPLL with phase change 1/2 reported
					; error.
					; Assumes 2 flags are sent before
					; straddles true bit edge worst case
					; with no noise induced crossings
	jlt	<addit			; if pi if less than a, move 2 degrees
					; to zero
	move	y:pil,x1
	cmp	x1,a
	jlt	<nocrct
	sub	x0,a
	jmp	<nocrct
addit	add	x0,a
nocrct	move	a,y:clkph

	bclr	#8,x:INTREQ
	jcc	<ckafq
	move	x:(r3),a
	abs	a	x:(r7),b
	abs	b	y:dcdoff,y1
	sub	b,a
	asl	a	x:clkgn,x0
	asl	a	x:clkdcd,x1
	move	a,y0
	mpy	x0,y0,b	x:clksm,y0
	macr	x1,y0,b	
	move	b,x:clkdcd
	cmp	y1,b
	jlt	<dcdno
	bclr	#4,y:hdim
	jmp	<dbit
dcdno	bset	#4,y:hdim
	move	#0,y0
	move	#0,x0
	rep	#16
	move	y0,y:(r6)+	x0,x:(r2)+
	move	#$40,y0
	move	y0,y:(r6+n6)
	jmp	<ckafq
dbit	move	x:bit,x0
	clr	a	x0,x:(r2)+	y:(r6)+,y0
	rep	#15
	mac	x0,y0,a	x:(r2)+,x0	y:(r6)+,y0
	macr	x0,y0,a
	move	a,x:bit
	jlt	<dong
	move	#>0.2,b
	jmp	<doerr
dong	move	#>-0.2,b
doerr	sub	a,b
	move	b,x1
	move	#$3,y1
	mpy	x1,y1,b
	move	b,y1
	do	#16,clccf	
	move	y:(r6),y0 x:(r2)+,x0
	mpy	x0,y1,b
	add	y0,b
	move	b,y:(r6)+
clccf	move	x:bit,x0
	move	x0,x:(r2+n2)
	move	x0,b
	move	x:shfregr,a
	lsl	a	#>1,y0
	tst	b	(r2)-
	jlt	<negtb
	eor	y0,a

	; Descramble, only takes two instructions per tap, thanks 56001!

negtb	clr	b	a1,x:shfregr
	jclr	#0,x:shfregr,chk12
	eor	y0,b
chk12	jclr	#12,x:shfregr,chk17
	eor	y0,b
chk17	jclr	#17,x:shfregr,chkbit
	eor	y0,b
chkbit	jeq	<negb
posb	bset	#7,y:hdim		; send the bit to the host
	jmp	<sendit
negb	bclr	#7,y:hdim
sendit
	movep	y:hdim,y:<<HSTW		;send data before clock to stabelize

	bset	#5,y:hdim
	movep	y:hdim,y:HSTW

	bclr	#5,y:hdim
	movep	y:hdim,y:HSTW
	jclr	#1,x:<<M_HSR,ckafq

doled	move	#>0.0000016,y0
	move	x:bit,x0
	mpy	x0,y0,a	#>$0F,x1	;changed from $FF,x1 to $0F,x1
	and	x1,a
	move	a1,x1
	MSHL	x1,y0,8,a
	move	a0,x0
outl	move	#>$800000,a	;changed to $800000 from $080000
	or	x0,a
	movep	a1,x:M_HTX

ckafq	move	y:clkph,a
	move	y:clkfq,x0
	add	x0,a	x:tphase,x0
	cmp	x0,a	y:maskph,x0
	jlt	<stph
	and	x0,a
	bset	#8,x:INTREQ
	move	x:(r3),x0
	move	x0,x:bit
stph	move	a,y:clkph
	move	x:(r3)-,x0
	move	x:(r7)-,x0
	jmp	<loopt

;	INTERRUPT SERVICE ROUTINES

CH_B	movep	y:ADB,y:RXA		; receive sample
	movep	y:TXA,y:DAB
	bset	#0,x:INTREQ
CH_A	rti

	end
