	page	132,60
;	Analog FAX HF modem for port-1 of the DSP-1232/-2232.
;	Modified 15-Nov-93 for new bar graph communications protocol.
;	by Andy Madsen KB7B.
;	standard I/O 
	include 'ioequ'

;	interrupt equates
	include 'intequ'

;	bit shift macros
	include 'shifty'

;	DSP232 IO Equates
	include	'dsp232'

;	Numeric Macro's
;	include 'numerics'

midfreq	equ	1900*524288/9600
scale	equ	0.004
BLANKBG2	equ	$800800		;constnt blanks unused port-2 bar graph

	org	y:$30
RXA	dc	0
TXA	dc	0
HDIM	dc	$FC
dcdgo	dc	8338608
dcdgn	dc	50000
dcd	dc	0
dcdoff	dc	1200000
smpclk	dc	0
y1tmp	ds	1
tmpo	ds	1

	org	x:$30
INTREQ	dc	0
TXB	dc	$800000
RXB	ds	1
phase	dc	0			; receive phase
freq	dc	1900*524288/9600	; initial freq
freql	dc	(1440*524288)/9600	; lo freq allowed on PLL
freqh	dc	(2360*524288)/9600	; hi freq allowed on PLL
fgain	dc	2.0*scale		; freq  gain
pgain	dc	7.0*scale		; phase gain
tphase	dc	524288			; 2^19 top of the phase chart!
ophase	dc	0			; transmit phase
tmpa	ds	3

	org	y:$0
bp	dc       -562
	dc     -19296
	dc    -151301
	dc     -21641
	dc     106312
	dc     -31489
	dc     122173
	dc     501843
	dc     132304
	dc    -265400
	dc     197354
	dc    -380559
	dc   -2052488
	dc    -839496
	dc    2749527
	dc    2749527
	dc    -839496
	dc   -2052488
	dc    -380559
	dc     197354
	dc    -265400
	dc     132304
	dc     501843
	dc     122173
	dc     -31489
	dc     106312
	dc     -21641
	dc    -151301
	dc     -19296
	dc       -562

maskph	dc	$7FFFF			;  maskph = 524287

	org	y:$40
hilby
	dc     -16103
	dc     -53419
	dc      11770
	dc     186039
	dc      47011
	dc      43274
	dc     264347
	dc     -46263
	dc    -530370
	dc    -164794
	dc    -162406
	dc   -1031200
	dc      65468
	dc    2763102
	dc    1964702
	dc   -1964702
	dc   -2763102
	dc     -65468
	dc    1031200
	dc     162406
	dc     164794
	dc     530370
	dc      46263
	dc    -264347
	dc     -43274
	dc     -47011
	dc    -186039
	dc     -11770
	dc      53419
	dc      16103

	 org	y:$80
;	Lowpass filter for baseband

lpbb	dc      -73793
	dc      154462
	dc      159870
	dc      143842
	dc       58663
	dc      -91752
	dc     -253801
	dc     -340672
	dc     -265989
	dc       15884
	dc      480516
	dc     1029986
	dc     1519963
	dc     1808663
	dc     1808663
	dc     1519963
	dc     1029986
	dc      480516
	dc       15884
	dc     -265989
	dc     -340672
	dc     -253801
	dc      -91752
	dc       58663
	dc      143842
	dc      159870
	dc      154462
	dc      -73793
hst_buf	ds	1

	org	p:0
	jmp	<start

	org 	p:I_IRQA
	jsr	<CH_A

	org	p:I_IRQB
	jsr	<CH_B

	org	p:I_HSTTD
	jsr	<HST_XMT

	org	p:$40

start	bset	#M_HF2,x:<<M_HCR
IDLE	jset	#M_HF0,x:<<M_HSR,IDLE
	bclr	#M_HF2,x:<<M_HCR

	movep	#>BLANKBG2,x:M_HTX	;send BG 2 blanking to 64180 Host

	movep	x:TXB,y:DAB
	move	#bp,r1
	move	#29,m1
	move	#$100,r5		; Set up sinetable pointer

	move	#lpbb,r3		; Set up data filter (lowpass)
	move	#27,m3			; r3 is data and r7 is coeff
	move	#lpbb,r7		; Set up data filter (lowpass)
	move	#27,m7			; r3 is data and r7 is coeff

	bclr	#M_HTIE,x:<<M_HCR
	move	#$300,SR
	movep	#$C07,x:M_IPR		; Set up interrupts
	move	#0,SR

	bclr	#M_HF3,x:<<M_HCR
	bclr	#M_HF2,x:<<M_HCR

	bset	#M_HTIE,x:<<M_HCR	; turn on the bubble machine


loopt	bclr	#0,x:INTREQ
	jcc	<loopt
	move	n5,b			; Read phase into b1
	move	#>$40,x1		; Get ninety degrees
	move	#>$FF,y1		; Get 2pi mask
	add	x1,b	y:(r5+n5),y0	; add 90 degrees to get cos(phase)
					; whilst reading in sin(phase)
	and	y1,b			; mask to make between 0 and 2pi
					; whilst reading in the signal from
					; center of the delay line
	move	b1,n5			; move this into offset register
	move	y:RXA,x1	



	move	#bp,r4
	move	y:(r5+n5),x0		; Get cos(phase)=sin(phase+90)


	clr	a	x1,x:(r1)+	y:(r4)+,y1	; set up acc & ptr's

	rep	#29					; for bandpass filt
	mac	x1,y1,a	x:(r1)+,x1	y:(r4)+,y1	; do convolution
	move	#hilby,r4		; move the Hilbert table ptrs in
	macr	x1,y1,a					; last term and reset

	
	clr	b	x:(r1)+,x1	y:(r4)+,y1	; Set up Hilby
	rep	#29					; do convolution
	mac	x1,y1,b	x:(r1)+,x1	y:(r4)+,y1
	macr	x1,y1,b	(r1)-	; Do last multiply and reset data ptr


	move	a,x1
	move	b,y1


	mpy	-y0,y1,a 		; multiply signal * sin(phase)


	macr	x1,x0,a		; and hilbert Xform * cos and subtract

					; This give EXACTLY SIN(It's - Mine)
;	DCD

	mpy	y0,x1,b	y:dcd,y0	; Form sin^2 and get old dcd value
	macr	x0,y1,b	y:dcdgo,x0	; Form cos^2 and get old dcd gain
	mpy	x0,y0,b	b1,x1		; form dcdgo*dcd and move sin^2+cos^2
					; (b1) into x1
	move	y:dcdgn,y0		; get gain for update to DCD
	macr	x1,y0,b	y:dcdoff,y1	; form dcdgn*update and add to acc b
					; get the DCD offset
	move	b1,y:dcd		; store into dcd for next sample

	sub	y1,b			; subtract offset


	jlt	<dcdno			; Is the dcd positive?
	bclr	#0,y:HDIM		; Yes so set /DCD to zero
	jmp	<goon			; go on to next step
dcdno	bset	#0,y:HDIM		; DCD off, set /DCD to one

goon	move	a,y0			; move ph. err. est. in for gain
	move	x:fgain,x0		; Get freq. update gain
	mpy	x0,y0,a	x:freq,x0	; multiply times gain*pherr for update
					; to freq. and get old freq

	tfr	a,b	x:freql,x1	; set up b to do fq update and get	
					; lower fq rail for compare
	add	x0,b			; add freq correction to fq
	cmp	x1,b	x:freqh,x0	; Is the freq to low? Get freqh in case
	jgt	<chkhi			; phase is ok?
	move	x1,b			; No fq too low change to low
	jmp	<doph			; go update the phase
chkhi	cmp	x0,b			; is the freq too high?
	jlt	<doph			; No go to phase update
	move	x0,b			; Yes store high frequency
doph	move	x:phase,a		; Get phase
	move	x:pgain,x0
	mac	x0,y0,a
	add	b,a	y:maskph,y0	; add new fq to phase, get phase mask
	rnd	b	x:tphase,x0
	add	x0,a			; add 2*PI to make positive
	and	y0,a	b,x:freq	; store new freq
	move	a1,x1			; mask off by 0x7FFFF
 	move	a1,x:phase		; store updated phase
	MSHR	x1,y1,11,a
	move	a1,n5		; store offset into sine table

;	FILTER THE DATA	(sequence of frequency offsets)

	move	#>(1450*524288/9600),x1
	sub	x1,b
	move	b,x0
	MSHL	x0,y1,6,b
	move	b0,x1

bitflt	clr	a	x1,x:(r3)+	y:(r7)+,y1
	rep	#27
	mac	x1,y1,a	x:(r3)+,x1	y:(r7)+,y1
	macr	x1,y1,a	(r3)-
	abs	a

	move	a,x0
	move	#>0.000075,y0
	mpy	x0,y0,a

	move	a,y:hst_buf
	jmp	<loopt

;	INTERRUPT SERVICE ROUTINES

CH_A	movep	y:ADA,y:RXA		; receive sample
	movep	y:TXA,y:DAA
	bset	#0,x:INTREQ
CH_B	rti

HST_XMT	movep	y:hst_buf,x:M_HTX
	rti				; return from the transmit empty
					; interrupt
	end
