	page	132,60
;	AO-13 Port-1 modem for the DSP-1232/-2232
;	Modified 15-Nov-93 for new bar graph communications protocol.
;	by Andy Madsen KB7B.

;	standard I/O 
	include 'ioequ'

;	interrupt equates
	include 'intequ'

;	bit shift macros
	include 'shifty'

;	DSP232 IO Equates
	include	'dsp232'

;	Numeric Macro's
;	include 'numerics'

BLANKBG2	equ	$800800		;constnt blanks unused port-2 bar graph

	org	y:0
y1tmp	dc	0
RXA	dc	0
TXA	dc	$800000
maskph	dc	$7FFFF			;  maskph = 524287
clkph	dc	0
clkfq	dc	52429
dcdgo	dc	8378607
dcdgn	dc	10000
dcd	dc	0
dcdoff	dc	60000
pi	dc	$40000
clkcr	dc	5243
fgainl	dc	0.000025
pgainl	dc	0.001
fgainnl	dc	0.0001
pgainnl	dc	0.004
oldbit	dc	0
newbit	dc	0
bytect	dc	0
delay	dc	1
pio6	dc	43691
epio6	dc	240297

	org	x:0
INTREQ	dc	0
TXB	dc	$800000
phase	dc	0			; initial phase
freq	dc	104858			; freq  1600 Hz
freql	dc	85197			; freql 1000 Hz
freqh	dc	124518			; freqh 2200 Hz
tphase	dc	524288			; 2^19 top of the phase chart!
pgain	dc	0.001
pherr	dc	0
bitval	dc	0
hftm	dc	0
deman	dc	0
fbit	dc	0
sbit	dc	0
bitc	dc	0
tmp	dc	0

	 org	y:$20
;	Lowpass filter for baseband

lpbb	dc	 -85954
	dc	  22197
	dc	  71601
	dc	 122858
	dc	 138010
	dc	  86198
	dc	 -35807
	dc	-191584
	dc	-309270
	dc	-304759
	dc	-116511
	dc	 262086
	dc	 768410
	dc	1283007
	dc	1666673
	dc	1808600
	dc	1666673
	dc	1283007
	dc	 768410
	dc	 262086
	dc	-116511
	dc	-304759
	dc	-309270
	dc	-191584
	dc	 -35807
	dc	  86198
	dc	 138010
	dc	 122858
	dc	  71601
	dc	  22197
	dc	 -85954

	org	y:$40

hilby	dc	-72423
	dc	-209699
	dc	-120809
	dc	10126
	dc	-346117
	dc	-7629
	dc	113957
	dc	-346801
	dc	335161
	dc	677888
	dc	-230272
	dc	1753953
	dc	3947949
	dc	0
	dc	-3947949
	dc	-1753953
	dc	230272
	dc	-677888
	dc	-335161
	dc	346801
	dc	-113957
	dc	7629
	dc	346117
	dc	-10126
	dc	120809
	dc	209699
	dc	72423


	org	x:$60
sync	dc	$39
data	dc	0
tmpa	ds	3

	org	y:$60
syncl	dc	$15ED30
datal	dc	0
maskc	dc	$FF
hdim	dc	$F4


	org	x:$400
hstbuf	ds	512

	org	x:$80
datint	ds	1

	org	p:0
	jmp	<start

	org	p:I_IRQA
	jsr	CH_A

	org	p:I_IRQB
	jsr	CH_B

	org	p:I_HSTTD
	jsr	<HST_XMT

	org	p:$40

start	bset	#M_HF2,x:<<M_HCR
IDLE	jset	#M_HF0,x:<<M_HSR,IDLE
	bclr	#M_HF2,x:<<M_HCR

	movep	#>$B4,y:$FFEB
	movep	#>$00,y:$FFEA
	movep	#>$3,y:$FFEA

	movep	#>BLANKBG2,x:M_HTX	;send BG 2 blanking to 64180 Host


	move	#$300,SR
	movep	#>$C07,x:M_IPR		; Set up interrupts
	move	#0,SR


	move	#$100,r5		; Set up sinetable pointer
	move	#lpbb,r2		; Set up data filter (lowpass)
	move	#30,m2			; r6 is data and r2 is coeff
	move	#lpbb,r6		; filter is fifteen taps
	move	#30,m6			; 

	move	#datint,r3
	move	#19,m3
	move	#1,n3
	
	move	#hstbuf,r0
	move	#hstbuf,r7
	move	#511,m0
	move	#511,m7
	move	#hilby,r1
	move	#hilby,r4
	move	#26,m1
	move	#26,m4

 	move	#14,n1

	bclr 	#M_HF3,x:<<M_HCR	; Set the bits to let the host
	bclr	#M_HF2,x:<<M_HCR

loopt	bclr	#0,x:INTREQ
	jcc	<loopt

nmre	movep	y:hdim,y:HSTW	; get it and send it to the 85C30



	move	y:RXA,x0

	clr	a	x0,x:(r1)+	y:(r4)+,y0	; Set up Hilby
	rep	#26					; do convolution
	mac	-x0,y0,a	x:(r1)+,x0	y:(r4)+,y0
	macr	-x0,y0,a	(r1)-	; Do last multiply and reset data ptr
					; for next data sample
	move	n5,b1			; Read phase into b1
	move	#>$40,x1		; Get ninety degrees
	move	#>$FF,y1		; Get 2pi mask
	add	x1,b	y:(r5+n5),y0	; add 90 degrees to get cos(phase)
					; whilst reading in sin(phase)
	and	y1,b	x:(r1+n1),x0	; mask to make between 0 and 2pi
					; whilst reading in the signal from
					; center of the delay line
	move	b1,n5			; move this into offset register


	move	a1,x1

	move	y:(r5+n5),y1		; Get cos(phase)=sin(phase+90)

;	Get error estimate

	mpy	x1,y1,a 		; multiply signal*cos(phase)
	macr	-x0,y0,a		; and hilbert Xform(sig) * sin(phase)
					; and subtract
					; This gives data*SIN(It's - Mine)

;	Get data estimate,assuming error is `small enough'


	mpy	x0,y1,b			; Form hilb(sig)*cos(phase)
	macr	x1,y0,b	 		; +sig*sin(phase) to give data*
					; cos(It's - mine)

	jge	posb			; assuming small enough (It's - mine)
	neg	a			; negate the pherr if the bit < 0
posb	move	a1,x:pherr		; store it for future use
	move	a1,x0
	move	b1,x:bitval		; store noisy bit estimate
	mpy	-x0,x0,a	b1,x0	; compute Q^2 - I^2 for lock signal
	macr	x0,x0,a	y:dcdgn,y0	; 
	move	a1,x0
	mpy	x0,y0,a	y:dcd,x1
	move	y:dcdgo,y1
	macr	x1,y1,a	y:dcdoff,x0
	sub	x0,a	a1,y:dcd
	jlt	<dcdno			; Is the dcd positive?
	bclr	#0,y:hdim		; Yes so set /DCD to zero
	move	y:fgainl,x0
	move	y:pgainl,y0
	move	y0,x:pgain
	jmp	<goon			; go on to next step
dcdno	bset	#0,y:hdim		; DCD off, set /DCD to one
	move	y:fgainnl,x0
	move	y:pgainnl,y0
	move	y0,x:pgain
goon	move	x:pherr,y0		; move ph. err. est. in for fq gain
	mpy	x0,y0,a	x:freq,x0	; multiply times gain*pherr for update
					; to freq. and get old freq

					;  fq update and get lower fq rail for compare
	add	x0,a	x:freql,x1	; add freq correction to fq
	cmp	x1,a	x:freqh,x0	; Is the freq to low? Get freqh in case
	jge	<chkhi			; phase is ok?
	move	x1,a			; No fq too low change to low
	jmp	<doph			; go update the phase
chkhi	cmp	x0,a			; is the freq too high?
	jle	<doph			; No go to phase update
	move	x0,a			; Yes store high frequency
doph	move	x:pherr,x0		; Get the phase error estimate
	move	x:pgain,y0		; and the phase error gain
	mpy	x0,y0,b	x:phase,x1	; mpy to get phase update
	add	x1,b	x:tphase,x0	; and add old phase to pherr update
	add	a,b	y:maskph,y0	; add new fq to phase, get phase mask
	jge	<phok			; if phase not < 0 go jump ahead
	add	x0,b			; add 2*PI to make positive

phok	and	y0,b	a1,x:freq	; store new freq
	move	b1,x1			; mask off by 0x7FFFF
 	move	b1,x:phase		; store updated phase
	MSHR	x1,y1,11,a		; shift the phase so that integer
					; part is in a1 and fraction in 
					; a0.
	move	a1,n5			; store offset (integer part) into
					; sine table

;	FILTER THE DATA	(sequence of frequency offsets)

	move	x:bitval,x1

bitflt	clr	b	x1,x:(r2)+	y:(r6)+,y1
	rep	#30
	mac	x1,y1,b	x:(r2)+,x1	y:(r6)+,y1
	macr	x1,y1,b	(r2)-	
	asr	b

;	FILTER DONE


;	Do clock recovery and integrate and dump on clock
;

	move	y:clkfq,x0		; Get the clkph frequency
	move	y:clkph,a		; Get clkph phase
	add	x0,a	x:tphase,y1	; calculate phase, move 2*PI into x0

	move	a1,y:clkph
	cmp	y1,a	b1,x:(r3)
	jlt	<chkclk			; Is it a bit time?

	move	y:maskph,x0		; YES
	and	x0,a			; mask off to maintain mod 2PI
	move	a1,y:clkph
	

	move	#>0.05,y0
	move	b1,x:tmp
	clr	b	x:(r3)+,x0	; Move the first bit sample into x0
					; integrate over entire previous
					; 
	rep	#10			; over the seven samples. Add the sample
	mac	x0,y0,b	x:(r3)+,x0	; to B and move the pointer
	rep	#9
	mac	-x0,y0,b   x:(r3)+,x0	; subtract first bit half
	macr	-x0,y0,b		; do not rotate (r3)- yet, need it
					; as is to check for zero crossing
	tfr	b,a
	abs	b	x:deman,x0
	bchg	#0,x:hftm		; toggle which half bit we are on
	jcs	<scnd			; is it the second half?
	neg	b	a1,x:fbit	; No so take -abs(bit value) &
					; store the first bit for later use
	add	x0,b	#>-0.6,x0	; add -abs(bit) to x:deman, get rail
	cmp	x0,b	b1,x:deman	; cmp to rail, store just in case
	jge	<doled			; is it >= rail?
	move	x0,x:deman		; NO so replace with rail
	jmp	<doled			; go do leds
scnd	move	a1,x:sbit		; second half gets stored
	add	x0,b	#>0.6,x0	; and abs(bit) gets add to x:deman,
					; get the rail
	cmp	x0,b	b1,x:deman	; to big?  store deman just in case
	jle	<getdat			; is it small enough?
	move	x0,x:deman		; no store the rail
getdat	move	x:deman,b		; get the deman
	tst	b
	jlt	<fbitr			; is it the 1st?
	move	x:sbit,b		; no get second bit
	jmp	<tstb			; go slice it
fbitr	move	x:fbit,b		; the 1st bit is correct
tstb	tst	b			; slice it
	jle	<negbm			; does it slice negative?
posbm	move	#>1,y0			; No move a one into y0
	jmp	<slide			; go get ready to slide it thru state
					; machine, etc.
negbm	move	#0,y0			; it was negative, put 0 into y0
slide	move	y0,y:newbit		; store the new bit

	move	y:oldbit,a		; get the old bit
	eor	y0,a	y0,y:oldbit	; ex or with the new (NRZI-S), replace
					; old with the new
	move	a,y:newbit		; store the new again
;	jeq	<negp5			; is it a zero?
;	bset	#4,y:hdim		; nope, its a one
;	jmp	<st	
;negp5	bclr	#4,y:hdim		; output zero to the latch so we can
					; see
st	btst	#3,y:hdim		; TEST the flag that says we have found
					; sync so that next bit is sent out
	jcs	<datout			; should we output data?
	clr	a
	move	l:data,a10		; No, continue to check for sync
	asl	a	#>$FF,x0	; shift left and mask off shit bit
	and	x0,a	y:newbit,y0	; mask and get newbit
	clr	b
	move	a0,b1			; move low word into b
	or	y0,b			; or in the new bit
	move	b1,a0			; put it back in a
	move	l:sync,b10		; get the sync vector
	move	a10,l:data	; subtract the sync vector from
	sub	b,a
					; the new data and store the new data
	jne	<doled			; if the sync is not zero go do led
syncd	bset	#3,y:hdim		; sync pulse detected
	bset	#0,y:delay
	jmp	<doled			; go do the front panel display
datout	move	y:datal,a		; get the data
	lsl	a	#>$FF,x0	; left shift from the bottom, Hi order
					; bit is transmitted first
	and	x0,a	y:newbit,y0	; mask off eight, get new bit
	or	y0,a	#8,x0		; or it in, get 8 into a convenient
					; place
	move	y:bytect,b		; get the bit counter for the byte
	move	#1,x1			; get a one
	add	x1,b	a1,y:datal	; add it to the counter and store the
					; new data
	cmp	x0,b	b1,y:bytect	; have we shoved eight bits?, store
					; counter in case we haven't
	jlt	<anbit			; if it's less than 8, don't output
	move	#0,y0			; we have a byte, clear counter
	move	y0,y:bytect		; and store it
	move	a1,y:(r7)+		; send data to host output buffer
	bset	#M_HTIE,x:<<M_HCR	; set Host transmit empty interrupt
anbit	move	#>1,x1
	move	x:bitc,a 
	add	x1,a	#>4096,y0	
	cmp	y0,a	a1,x:bitc
	jlt	<bckclk
	move	#0,y0
	move	y0,x:bitc
	bclr	#3,y:hdim
	jmp	<bckclk

doled	jset	#M_HTIE,x:<<M_HCR,bckclk	; if interrupt is enable
						; clear out
	jclr	#M_HTDE,x:<<M_HSR,bckclk	; if there is data in the
						; pipe, clear out.
	btst	#3,y:hdim
	jcs	<bckclk

	bclr	#0,y:delay
	jcs	<bckclk
dofq	move	x:freq,a
;;	move	#>104858,x0
;;	sub	x0,a
;;	move	a1,x0
;;	move	#>0.0002,y0
;;	mpy	x0,y0,a	#>$F00,x0	;changed move here to $F00 from $800.
;;	move	a1,x1
;;	MSHL	x1,y0,8,a		;changed from shift left 16 to 8
;;	move	a0,a1
;;	and	x0,a			;changed from or to and
;;	bset	#M_HF3,x:<<M_HCR
;;	bclr	#M_HF2,x:<<M_HCR
;;	movep	a1,x:M_HTX
;doled	move	x:freq,a
	move	#>104858,x0
	sub	x0,a
	move	a1,x0
	move	#>0.0002,y0
	mpy	x0,y0,a	#>$0FF,y1	;scale frequency diff to -5 to +4 (2s comp)
	move	a1,x1
	MSHL	x1,y0,8,a
	move	#>0.001525873,y0	;new scaling factor for freq. error
	mpy	x0,y0,b	#>$F00,x1	;new multiply and scale
	and	y1,b			;new mask all but LSbyte of B1
	move	b1,x0			;new save b1 to OR later
	move	a0,a1
	and	x1,a			;mask all but LED info nibble
	or	x0,a	;new to combine frequency error byte with led byte
	bset	#M_HF3,x:<<M_HCR
	bclr	#M_HF2,x:<<M_HCR
	movep	a1,x:M_HTX

bckclk	move	x:tmp,b
chkclk	move	y:clkph,a
	move	b1,y0			; store bit in x0
	move	x:(r3+n3),x0		; Get previous sample in integrator
					; delay line
	mpy	x0,y0,b	y:pio6,x1	; multiply them and get pi for phase
					; comparison to adjust clkph

	move	y:clkcr,x0
	jgt	<nocrct			
	cmp	x1,a	y:epio6,y0	; compare pi with clock phase and
					; DPLL with phase change 1/2 reported
					; error.
					; Assumes 2 flags are sent before
					; straddles true bit edge worst case
					; with no noise induced crossings
	jlt	<nocrct
					; to zero
	cmp	y0,a
	jgt	<addit
	sub	x0,a
	jmp	<nocrct			; jump to see if bit time
addit	add	x0,a			; we were greater than 2*pi so move
nocrct	move	x:(r3)-,x0
	move	a1,y:clkph

	jmp	<loopt

;	INTERRUPT SERVICE ROUTINES

CH_A
;	movep	y:TXA,y:DAA		; send it
;	movep	x:TXB,y:DAB
	movep	y:ADA,y:RXA		; save it
	bset	#0,x:INTREQ		; set samples done bit
CH_B	rti

HST_XMT	move	a2,x:tmpa+2
	move	a1,x:tmpa+1
	move	a0,x:tmpa
	move	r0,a
	move	y1,y:y1tmp
					; get the to_transmit buffer pointer
					; into the accumulator (a is unused
					; above)
	move	r7,y1			; get the sample buffer into y1
	cmp	y1,a			; are they the same?
	jne	<snd			; jump on different
	bclr	#M_HTIE,x:<<M_HCR	; the buffer pointers are the same
					; clear the interrupt enable
	jmp      <rtn			; return from the transmit empty
					; interrupt
snd	bclr 	#M_HF3,x:<<M_HCR	; Set the bits to let the host
	bclr	#M_HF2,x:<<M_HCR
;
;	movep	y:(r0)+,x:M_HTX		; they are not so the buffer still
					; has stuff in it to send, send it
					; and advance the pointer
	move	#>$00FFFF,y1		;test
;
	move	y:(r0)+,a		; test they are not so the buffer still
					; has stuff in it to send, send it
					; and advance the pointer
;
	and	y1,a			;test
	move	#>$020000,y1		;test
	or	y1,a			;test
	movep	a,x:M_HTX		;test

rtn	move	x:tmpa+2,a2
	move	x:tmpa+1,a1
	move	x:tmpa,a0
	move	y:y1tmp,y1
	rti				; return from the transmit empty
					; interrupt
	end
