 	page	132,60
;	RTTY/TOR 1200 bps ASCII OSCAR-11 port-1 modem for DSP-1232/-2232
;	Modified 15-Nov-93 for new bar graph communications protocol.
;	by Andy Madsen KB7B.

;	standard I/O 
	include 'ioequ'

;	interrupt equates
	include 'intequ'

;	bit shift macros
	include 'shifty'

;	DSP232 IO Equates
	include	'dsp232'

;	Numeric Macro's
;	include 'numerics'

ONE	equ	0.125
BLANKBG2	equ	$800800		;constnt blanks unused port-2 bar graph

	org	y:0
RXA	dc	0
TXA	dc	0
pher	dc	0			; phase error
maskph	dc	$7FFFF			;  maskph = 524287
clkph	dc	0
clkfq	dc	65536
dcdgo	dc	8288608
dcdgn	dc	100000
dcd	dc	0
dcdoff	dc	800000
oldres	dc	0
result	dc	0
pi	dc	$40000
fmtnc	dc	0

	org	x:0
INTREQ	dc	0
TXB	dc	0
RXB	dc	0
phase	dc	0			; initial phase 	0
freq	dc	92843			; freq  1700 Hz		1
freql	dc	61075			; freql 1200 Hz		2
tfreql	dc	65536			; freql 1200 Hz		2
tfreqh	dc	120149			; freqh 2200 Hz		3
freqh	dc	132000			; freqh 2200 Hz		3
fgain	dc	0.075			; freq  gain
pgain	dc	0.0
tphase	dc	524288			; 2^19 top of the phase chart!
ophase	dc	0			; transmit phase
clkcr	dc	25000
tmp	dc	0
txclk	dc	0

	org	y:$10
bp	dc	33610
	dc	-505962
	dc	-262299
	dc	-103671
	dc	-1351253
	dc	-1591189
	dc	1579943
	dc	3966424
	dc	1579943
	dc	-1591189
	dc	-1351253
	dc	-103671
	dc	-262299
	dc	-505962
	dc	33610

	org	x:$20
aflim	dc	0

	 org	y:$80
;	Lowpass filter for baseband

lpbb	dc	    1111
	dc	   89824
	dc	   79969
	dc	   72521
	dc	   24087
	dc	  -62528
	dc	 -164899
	dc	 -242921
	dc	 -248542
	dc	 -141500
	dc	   93937
	dc	  438301
	dc	  836562
	dc	 1209541
	dc	 1474929
	dc	 1571009
	dc	 1474929
	dc	 1209541
	dc	  836562
	dc	  438301
	dc	   93937
	dc	 -141500
	dc	 -248542
	dc	 -242921
	dc	 -164899
	dc	  -62528
	dc	   24087
	dc	   72521
	dc	   79969
	dc	   89824
	dc	    1111

	org	y:$40

hilby	dc	-72423
	dc	-209699
	dc	-120809
	dc	10126
	dc	-346117
	dc	-7629
	dc	113957
	dc	-346801
	dc	335161
	dc	677888
	dc	-230272
	dc	1753953
	dc	3947949
	dc	0
	dc	-3947949
	dc	-1753953
	dc	230272
	dc	-677888
	dc	-335161
	dc	346801
	dc	-113957
	dc	7629
	dc	346117
	dc	-10126
	dc	120809
	dc	209699
	dc	72423

	org	y:$60
pio2	dc	$40
maskc	dc	$FF
hdim	dc	$FC

	org	x:$60
datint	dc	0

	org	x:$68
r1af	dc	0
r1hlb	dc	0
r4hlb	dc	0

	org	p:0
	jmp	<start

	org	p:I_IRQA
	jsr	<CH_A

	org	p:I_IRQB
	jsr	<CH_B

	org	p:$40

start	bset	#M_HF2,x:<<M_HCR
IDLE	jset	#M_HF0,x:<<M_HSR,IDLE
	bclr	#M_HF2,x:<<M_HCR

	movep	#>BLANKBG2,x:M_HTX	;send BG 2 blanking to 64180 Host

	move	#$300,SR
	movep	#$7,x:$FFFF		; Set up interrupts
	move	#0,SR

	move	#bp,r0
	move	#14,m0			; Set up band pass filter control regs
	move	#bp,r4
	move	#14,m4

	move	#$100,r5		; Set up sinetable pointer
	move	#lpbb,r2		; Set up data filter (lowpass)
	move	#30,m2			; r6 is data and r2 is coeff
	move	#lpbb,r6		; filter is fifteen taps
	move	#30,m6			; 

	move	#datint,r3
	move	#7,m3
	move	#1,n3
	
	move	#>hilby,y0
	move	y0,x:r1hlb
	move	y0,x:r4hlb

	move	#>aflim,y0
	move	y0,x:r1af


	move	#14,n1


loopt	bclr	#0,x:INTREQ
	jcc	<loopt

	move	x:r1af,r1
	move	#14,m1

	move	y:RXA,x0

	clr	a	x0,x:(r0)+	y:(r4)+,y0	; set up acc & ptr's
	rep	#14					; for bandpass filt
	mac	x0,y0,a	x:(r0)+,x0	y:(r4)+,y0	; do convolution
	macr	x0,y0,a	(r0)-				; last term and reset

	move	x:r4hlb,r4		; move the Hilbert table ptrs in
	move	#26,m4			; do mod 27 arithmetic

	move	r1,x:r1af		; store the after limiter data pointer
	move	x:r1hlb,r1		; Get Hilbert data pointer

	move	#26,m1			; store 26 in module
	move	a1,x0			; Store optimal detector output
					; in x0 for Hilbert filter

	clr	a	x0,x:(r1)+	y:(r4)+,y0	; Set up Hilby
	rep	#26					; do convolution
	mac	-x0,y0,a	x:(r1)+,x0	y:(r4)+,y0
	macr	-x0,y0,a	(r1)-	; Do last multiply and reset data ptr
					; for next data sample
	move	r1,x:r1hlb		; Preserve hilbert data line

	move	n5,b1			; Read phase into b1
	move	#>$40,x1		; Get ninety degrees
	move	#>$FF,y1		; Get 2pi mask
	add	x1,b	y:(r5+n5),y0	; add 90 degrees to get cos(phase)
					; whilst reading in sin(phase)
	and	y1,b	x:(r1+n1),x0	; mask to make between 0 and 2pi
					; whilst reading in the signal from
					; center of the delay line
	move	b1,n5			; move this into offset register
	move	a1,x1

	move	y:(r5+n5),y1		; Get cos(phase)=sin(phase+90)

	mpy	x1,y1,a 		; multiply signal * sin(phase)


	macr	-x0,y0,a		; and hilbert Xform * cos and subtract
					; This give EXACTLY SIN(It's - Mine)

;	DCD

	mpy	x0,y1,b	y:dcd,x0	; Form sin^2 and get old dcd value
	macr	x1,y0,b	y:dcdgo,y0	; Form cos^2 and get old dcd gain
	mpy	x0,y0,b	b1,x1		; form dcdgo*dcd and move sin^2+cos^2
					; (b1) into x1
	move	y:dcdgn,y1		; get gain for update to DCD
	macr	x1,y1,b	y:dcdoff,y0	; form dcdgn*update and add to acc b
					; get the DCD offset
	move	b1,y:dcd		; store into dcd for next sample
	sub	y0,b			; subtract offset
	jlt	<dcdno			; Is the dcd positive?
	bclr	#0,y:hdim		; Yes so set /DCD to zero
	jmp	<goon			; go on to next step
dcdno	bset	#0,y:hdim		; DCD off, set /DCD to one
 
goon	move	a1,y0			; move ph. err. est. in for gain

	move	x:fgain,x0		; Get freq. update gain
	mpy	x0,y0,a	x:freq,x0	; multiply times gain*pherr for update
					; to freq. and get old freq

	tfr	a,b	x:freql,x1	; set up b to do fq update and get	
					; lower fq rail for compare
	add	x0,b			; add freq correction to fq
	cmp	x1,b	x:freqh,x0	; Is the freq to low? Get freqh in case
	jgt	<chkhi			; phase is ok?
	move	x1,b			; No fq too low change to low
	jmp	<doph			; go update the phase
chkhi	cmp	x0,b			; is the freq too high?
	jlt	<doph			; No go to phase update
	move	x0,b			; Yes store high frequency
doph	move	x:phase,a		; Get phase
	move	x:pgain,x0
	macr	x0,y0,a
	add	b,a	y:maskph,y0	; add new fq to phase, get phase mask
	jge	<phok			; if phase not < 0 go jump ahead
	move	x:tphase,x0		; if so, get 2*PI
	add	x0,a			; add 2*PI to make positive

phok	and	y0,a	b1,x:freq	; store new freq
	move	a1,x1			; mask off by 0x7FFFF
 	move	a1,x:phase		; store updated phase
	MSHR	x1,y1,11,a
	move	a1,n5		; store offset into sine table

;	FILTER THE DATA	(sequence of frequency offsets)

	move	#>98304,x1
	sub	x1,b
	move	b1,x0
	MSHL	x0,y1,7,b
	move	b0,x1

bitflt	clr	b	x1,x:(r2)+	y:(r6)+,y1
	rep	#30
	mac	x1,y1,b	x:(r2)+,x1	y:(r6)+,y1
	macr	x1,y1,b	(r2)-


;	FILTER DONE
;	Do clock recovery and integrate and dump on clock
;
	tst	b
	jlt	<negb
	bset	#3,y:hdim		; send the bit to the host
	jmp	<sendit
negb	bclr	#3,y:hdim
sendit	movep	y:hdim,y:HSTW		; states, this should easily exceed
					; Store bit sample in integrator
					; delay line and place pointer on
					; previous sample

	jclr	#1,x:M_HSR,loopt
doled	move	b,x0
	move	#>0.00000075,y0
	mpy	x0,y0,a	#>$F00,x0	;changed move here to $F00 from $800.
	move	a1,x1
	MSHL	x1,y0,8,a		;changed from shift left 16 to 8
	move	a0,a1
	and	x0,a			;changed from or to and
	movep	a1,x:M_HTX
	jmp	<loopt			; the minimum requirements


;	INTERRUPT SERVICE ROUTINES
;	Cannot use y0 below as interrupts are not turned off

	org	P:$1F4
CH_A	movep	y:ADA,y:RXA		; receive sample
;	movep	y:TXA,y:DAA
	bset	#0,x:INTREQ
CH_B	rti

;	include	'stdint'

	end
