	page	132,60
;	DSP-1232/-2232 Modem 50: p1 Packet 1200 bps MSK
;	Modified 15-Nov-93 for new bar graph communications protocol.
;	by Andy Madsen KB7B.

;	standard I/O 
	include 'ioequ'

;	interrupt equates
	include 'intequ'

;	bit shift macros
	include 'shifty'

;	DSP232 IO Equates
	include	'dsp232'

;	Numeric Macro's
;	include 'numerics'

BLANKBG2	equ	$800800		;constnt blanks unused port-2 bar graph

	org	x:$300
INTREQ	dc	0
phase	dc	0			; receive phase
freq	dc	1700*524288/9600	; initial freq
freql	dc	(1140*524288)/9600	; lo freq allowed on PLL
tfreql	dc	(1200*524288)/9600	; lo transmit tone
tfreqh	dc	(1800*524288)/9600	; hi transmit tone
freqh	dc	(1860*524288)/9600	; hi freq allowed on PLL
fgain	dc	0.0271			; freq  gain
pgain	dc	0.01			; phase gain
tphase	dc	524288			; 2^19 top of the phase chart!
ophase	dc	0			; transmit phase
xn5	dc	0
tmp	dc	0
txclk	dc	0
clkcr	dc	0
clksm   dc      0.998
clkgn	dc	0.02
cpgain	dc	0.005
clkdcd	dc	0

	org	x:$20
datint	ds	16

	org	y:$20
datfil	 dc	        294539
	 dc	        225803
	 dc	       -187634
	 dc	       -827488
	 dc	      -1119001
	 dc	       -593542
	 dc	        557964
	 dc	       1515078
	 dc	       1515078
	 dc	        557964
	 dc	       -593542
	 dc	      -1119001
	 dc	       -827488
	 dc	       -187634
	 dc	        225803
	 dc	        294539

	org	y:$0
bp
	dc        -75576
	dc          6519
	dc         68134
	dc        164579
	dc        217943
	dc        118441
	dc        -31236
	dc         34422
	dc        144768
	dc       -340083
	dc      -1321715
	dc      -1411627
	dc        260011
	dc       2234323
	dc       2234323
	dc        260011
	dc      -1411627
	dc      -1321715
	dc       -340083
	dc        144768
	dc         34422
	dc        -31236
	dc        118441
	dc        217943
	dc        164579
	dc         68134
	dc          6519
	dc        -75576
	
	org	y:$30
RXA	dc	0
TXA	dc	0
fmtnc	dc	0
HDIM	dc	$FC
clkph	dc	0
clkfq	dc	524288*1200/9600
dcdgo	dc	8338608
dcdgn	dc	50000
dcd	dc	0
dcdoff	dc	1200000
pi	dc	$40000

;	Hilbert transform for complex phase and lock detector
	org	y:$40
hilby
	dc         92902
	dc         68606
	dc         65933
	dc         90812
	dc          -211
	dc       -230092
	dc       -282160
	dc       -104884
	dc       -237113
	dc       -718518
	dc       -426838
	dc       1176011
	dc       2399013
	dc       1278354
	dc      -1278354
	dc      -2399013
	dc      -1176011
	dc        426838
	dc        718518
	dc        237113
	dc        104884
	dc        282160
	dc        230092
	dc           211
	dc        -90812
	dc        -65933
	dc        -68606
	dc        -92902

maskc	dc	$FF
minb	dc	0
maxb	dc	0
maskph	dc	$7FFFF			;  maskph = 524287

	 org	y:$80
;	Lowpass filter for baseband

lpbb	dc	 -96206
	dc	-227834
	dc	-206459
	dc	-188825
	dc	  29711
	dc	 355232
	dc	 794132
	dc	1217881
	dc	1537725
	dc	1651896
	dc	1537725
	dc	1217881
	dc	 794132
	dc	 355232
	dc	  29711
	dc	-188825
	dc	-206459
	dc	-227834
	dc	 -96206

	org	x:$F0
RXB	ds	1
TXB	ds	1

	org	p:0
	jmp	<start

	org 	p:I_IRQA
	jsr	<CH_A

	org 	p:I_IRQB
	jsr	<CH_B

	org	p:$40

start	bset	#M_HF2,x:<<M_HCR
IDLE	jset	#M_HF0,x:<<M_HSR,IDLE
	bclr	#M_HF2,x:<<M_HCR

	movep	#>BLANKBG2,x:M_HTX	;send BG 2 blanking to 64180 Host

	move	#bp,r1
	move	#27,m1
	move	#$100,r5		; Set up sinetable pointer

	move	#lpbb,r2		; Set up data filter (lowpass)
	move	#18,m2			; r6 is data and r2 is coeff
	move	#lpbb,r6		; filter is 17 taps
	move	#18,m6			; 

	move	#datint,r3
	move	#15,m3			; data will be averaged over 32 samples
					; after out estimated clock phase goes
					; across 2*PI.
	move	#1,n3			; offset to detect  zero crossings
					; for the DPLL
	

					; so we've setup aflim pointers in
					; memory here



	move	#$300,SR
	movep	#$7,x:$FFFF		; Set up interrupts
	move	#0,SR


loopt	bclr	#0,x:INTREQ
	movep	y0,y:$FFF4
	jcc	<loopt

	move	x:txclk,a	; get txclk counter
	move	#1,x0		; add one to it
	add	x0,a
	move	a1,x:txclk	; save it
	move	#8,x0		; is it 8?
	cmp	x0,a	#4,x1	; compare and get halfbittime ready to compare
	jeq	<stlow		; was it fullbittime?
	cmp	x1,a		; no, check if its halfbittime
	jne	<dodat		; none of the above, move on
	movep	y:HSTR,y:fmtnc  ; mib bit clock, read bit.
	bset	#2,y:HDIM	; set clock bit high
	movep	y:HDIM,y:HSTW	; get it and send it to the 85C30
	jmp	<dodat		; move on

stlow	move	#0,x0
	move	x0,x:txclk	; the clock time was fullbittime (i.e. 0)
	bclr	#2,y:HDIM	; clear the clock bit
	movep	y:HDIM,y:HSTW	; get it and send it to the 85C30

dodat	move	n5,b			; Read phase into b1
	move	#>$40,x1		; Get ninety degrees
	move	#>$FF,y1		; Get 2pi mask
	add	x1,b	y:(r5+n5),y0	; add 90 degrees to get cos(phase)
					; whilst reading in sin(phase)
	and	y1,b			; mask to make between 0 and 2pi
					; whilst reading in the signal from
					; center of the delay line
	move	b1,n5			; move this into offset register
	move	#bp,r4
	move	y:RXA,x1	

	move	y:(r5+n5),x0		; Get cos(phase)=sin(phase+90)


	clr	a	x1,x:(r1)+	y:(r4)+,y1	; set up acc & ptr's

	rep	#27					; for bandpass filt
	mac	x1,y1,a	x:(r1)+,x1	y:(r4)+,y1	; do convolution
	move	#hilby,r4		; move the Hilbert table ptrs in
	macr	x1,y1,a					; last term and reset

	
	clr	b	x:(r1)+,x1	y:(r4)+,y1	; Set up Hilby
	rep	#27					; do convolution
	mac	x1,y1,b	x:(r1)+,x1	y:(r4)+,y1
	macr	x1,y1,b	(r1)-	; Do last multiply and reset data ptr



	move	a,x1
	move	b,y1


	mpy	-y0,y1,a 		; multiply signal * sin(phase)


	macr	x1,x0,a		; and hilbert Xform * cos and subtract

					; This give EXACTLY SIN(It's - Mine)
;	DCD
	mpy	y0,x1,b	y:dcd,y0	; Form sin^2 and get old dcd value
	macr	x0,y1,b	y:dcdgo,x0	; Form cos^2 and get old dcd gain
	mpy	x0,y0,b	b1,x1		; form dcdgo*dcd and move sin^2+cos^2
					; (b1) into x1
	move	y:dcdgn,y0		; get gain for update to DCD
	macr	x1,y0,b	y:dcdoff,y1	; form dcdgn*update and add to acc b
					; get the DCD offset
	move	b1,y:dcd		; store into dcd for next sample

	sub	y1,b			; subtract offset


	jlt	<dcdno			; Is the dcd positive?
	bclr	#0,y:HDIM		; Yes so set /DCD to zero
	jmp	<goon			; go on to next step
dcdno	bset	#0,y:HDIM		; DCD off, set /DCD to one

goon	move	a,y0			; move ph. err. est. in for gain
	move	x:fgain,x0		; Get freq. update gain
	mpy	x0,y0,a	x:freq,x0	; multiply times gain*pherr for update
					; to freq. and get old freq

	tfr	a,b	x:freql,x1	; set up b to do fq update and get	
					; lower fq rail for compare
	add	x0,b			; add freq correction to fq
	cmp	x1,b	x:freqh,x0	; Is the freq to low? Get freqh in case
	jgt	<chkhi			; phase is ok?
	move	x1,b			; No fq too low change to low
	jmp	<doph			; go update the phase
chkhi	cmp	x0,b			; is the freq too high?
	jlt	<doph			; No go to phase update
	move	x0,b			; Yes store high frequency
doph	move	x:phase,a		; Get phase
	move	x:pgain,x0
	mac	x0,y0,a
	add	b,a	y:maskph,y0	; add new fq to phase, get phase mask
	rnd	b	x:tphase,x0
;	rnd	b
	tst	a
	jge	<phok			; if phase not < 0 go jump ahead
	add	x0,a			; add 2*PI to make positive
phok	and	y0,a	b1,x:freq	; store new freq
	move	a1,x1			; mask off by 0x7FFFF
 	move	a1,x:phase		; store updated phase
	MSHR	x1,y1,11,a
	move	a1,x:xn5		; store offset into sine table

;	FILTER THE DATA	(sequence of frequency offsets)

	move	#>((1500*524288)/9600),x1
	sub	x1,b
	move	b,x0
	MSHL	x0,y1,7,b
	move	b0,x1

bitflt	clr	b	x1,x:(r2)+	y:(r6)+,y1
	rep	#18
	mac	x1,y1,b	x:(r2)+,x1	y:(r6)+,y1
	macr	x1,y1,b	(r2)-	



;	FILTER DONE


;	Do clock recovery and integrate and dump on clock
;

	move	b,x0
	mpy	x0,x0,a			; square data signal to produce
					; clk tone

	asl	a
	move	#datfil,r4
	move	a,x1			; store clock signal for use


	clr	a	x1,x:(r3)+	y:(r4)+,y1
	rep	#15
	mac	x1,y1,a	x:(r3)+,x1	y:(r4)+,y1
	macr	x1,y1,a	(r3)-
	move	a,x1
	move	y:clkph,x0		; get the current clock phase
					; derivation and in memory
	MSHR	x0,y0,11,a
	move	a1,n5			; store this in the offset pointer
	move	#>$40,x0		; get cosine offset
	move	#>$FF,y1		; Get 2pi mask
	add	x0,a	y:(r5+n5),y0	; Add cosine offset and retrieve sin
	and	y1,a	#$80,y1		; mask off for mod 2pi for cosine
	move	a1,n5			; store pointer in indirect register

	nop				; wait for hardware to make ready n5
	mpyr	-x1,y0,a	y:(r5+n5),y0 	; multiply -sin times clock tone
					; and retrieve cosine
	move	a,x:clkcr		; store phase error estimate


	mpyr	x1,y0,a	x:clkgn,x1	; multiply cos times clk tone.  When
					; in lock this will provide a constant
					; DC bias which when smoothed will
					; give indication of data lock
					; at the same time get clk err gain
	move	a,x0			; store lock signal in x0
	mpy	x0,x1,a	x:clkdcd,x0	; multiply by clk err gain and get
					; the old clkdcd value
	move	x:clksm,x1		; get clk smoother constant for
					; exponential decay filter
	macr	x0,x1,a	x:cpgain,x0	; multiply old clkdcd by decay rate
					; and add to the new clk dcd signal
					; retrieve clk phase gain
	move	a,x:clkdcd		; store new clk dcd

	move	x:clkcr,y0		; get clk phase detector signal
	mpyr	x0,y0,a	y:clkph,x0	; multiply phase detector signal
					; by gain and retrieve clock phase
	add	x0,a
	move	a,y:clkph	; is it bigger than 2pi and store it
	bclr	#8,x:INTREQ
	jcc	<ckafq
;	Do clock recovery and integrate and dump on clock
;
	tst	b

	jlt	<negb
	bset	#3,y:HDIM		; send the bit to the host
	jmp	<sendit
negb	bclr	#3,y:HDIM
sendit
	movep	y:HDIM,y:<<HSTW		;send data before clock to stabelize

	bset	#1,y:HDIM
	movep	y:HDIM,y:HSTW		; playing cautious, I set the bit

	bclr	#1,y:HDIM		; then I bang it high.  With 3 wait
	movep	y:HDIM,y:HSTW		; states, this should easily exceed
					; Store bit sample in integrator
					; delay line and place pointer on
					; previous sample
	jclr	#1,x:<<M_HSR,ckafq
doled	move	#>0.0000012,y0
	move	b,x0
mul	mpy	x0,y0,a	#>$F00,x0	;changed move here to $F00 from $800.
	move	a1,x1
	MSHL	x1,y0,8,a		;changed from shift left 16 to 8
	move	a0,a1
	and	x0,a			;changed from or to and
	movep	a1,x:M_HTX

ckafq	move	y:clkph,a
	move	y:clkfq,x0
	add	x0,a	x:tphase,x0
	cmp	x0,a	y:maskph,x0
	jlt	<stph
	and	x0,a
	bset	#8,x:INTREQ
stph	move	a,y:clkph

;	Transmitter code follows

	jset	#1,y:<<HSTR,xmtmk
	move	#bp,r4
	move	#$80,x0
	move	x0,y:TXA
	move	x:xn5,n5
	jmp	<loopt
xmtmk	jclr	#3,y:<<HSTR,lotone	; Is the bit a zero?
	move	x:tfreql,y0		; No so load up hi tone freq
	jmp	<comph			; goto phase update
lotone	move	x:tfreqh,y0		; The bit was a zero, load up lotone
comph	move	x:ophase,a		; Get the output phase
	add	y0,a	y:maskph,y1	; add the current freq and get the
					; Mod 2PI mask
	and	y1,a			; mask off for the next phase
	move	a1,x0			; Get phase read to pick off table
	move	#@pow(2,-11),y0		; offset to value by shifting right
	mpy	x0,y0,a	x0,x:ophase	; eleven bits and leaving top eight
					; and store the new output phase
	move	a1,n5			; store this in the offset pointer

;	We do a linear interpolation to clean up the crud
	move	#>1,x0
	move	y:(r5+n5),y0
	add	x0,a	y0,b
	neg	b	#>$FF,y1
	and	y1,a
	move	a1,n5
	nop
	move	y:(r5+n5),x0
	add	x0,b
	clr	a
	move	a0,a1
	lsr	a	b1,x0
	move	a1,x1
	move	y0,b
	macr	x1,x0,b
	asr	b
txfix	move	#$80,x0			; Move the non 2's binary offset for
					; D/A into position
	add	x0,b	x:xn5,n5	; add D/A fixup and retrieve PLL phase

	move	b1,y:TXA		; move output value into holding place
	jmp	<loopt			; the minimum requirements

;	INTERRUPT SERVICE ROUTINES

	org	P:$1F4
CH_A	movep	y:ADA,y:RXA		; receive sample
	movep	y:TXA,y:DAA
	bset	#0,x:INTREQ
CH_B	rti

	end

